// ++ IMPORTANT NOTICE --
//
// +++++++       This file is UTF-8.
// +++++++       Please adjust you text editor prior to saving any changes!
//
// ++ IMPORTANT NOTICE --

//https://developer.mozilla.org/en/nsIAbCard%2f%2fThunderbird3

// if(!reminderfox) var reminderfox = {};
if (!reminderfox.abCard) reminderfox.abCard = {};


/**
 *   Add a Reminder for a selected 'Contact' of the TB / ADDRESSBOOK
 *
 *  //gW - Guenter Wahl ...    vers. 01. August 2007 15:03
 *
 * The ABcard items added to the output (reminder.notes) are
 * configured with a 'reminderfox.abCard.items'-string
 * which is read from/written to the 'rmFx.abCardItems' TB-prefs.
 *
 * Valid items are all addressbook/card items, but only the following
 * have a 'locale' entry. For the others their item name is displayed.
 */
/*
		- LabelContact
			- DisplayName
			- NickName
			- PrimaryEmail
			- SecondEmail
			- ScreenName

		- LabelHome
			- HomeAddress

		- LabelWork
			- WorkAddress

		- LabelPhone
			- CellularNumber
			- FaxNumber
			- PagerNumber

		- LabelOther
			- Costom1 .. 4


	'reminderfox.abCard.items'-string interpretation:

		!item				generates 'nameString' tab 'dataOfNameString'
		item				generates 'dataOfNameString' only
		item,[!]item		items separated with comma are generated as
							data output on same line separated by space
		;					delimiter for generating a CR for the output
		//					an entry beginning with // is treated as comment
							which is not written to the output

		- Items containing a substring of 'Label' are interpreted as header lines.

		- Items with a leading 'X' are skipped for output.
		  This is a easy way to skip them, but hold them at the
		  standard place in the default 'reminderfox.abCard.items'-String.

		- The 'Category' items need not to be added to the
		  interpretation string, it's added to rmFx-field 'Categories'

		- 'Custom1..4'-item labels
			With the extension "MoreColsForAddressBook"
				https://nic-nac-project.org/~kaosmos/morecols-en.html
			installed, the 'labels' can be set individually and are
			stored in the prefs.js parameters
			"morecols.custom"+num+".label"  (num= 1...4)
			Those settings are read if xpi is installed.

*/

reminderfox.abCard.itemsUS = "// US version;"
				+ "LabelContact;"
					+ "!DisplayName;"
					+ "X!LastName,XFirstName;"
					+ "!PrimaryEmail,XSecondEmail;"

				+ "LabelPhone;"
					+ "!HomePhone,!FaxNumber;"
					+ "!WorkPhone;"
					+ "!CellularNumber;"

				+ "LabelHome;"
					+ "HomeAddress,HomeAddress2;"
					+ "HomeCity,HomeState,HomeZipCode;"
					+ "HomeCountry;"

				+ "LabelWork;"
					+ "JobTitle;"
					+ "Company,Department;"
					+ "WorkAddress,WorkAddress2;"
					+ "WorkCity,WorkState,WorkZipCode;"
					+ "WorkCountry;"

				+ "LabelOther;"
					+ "!Custom1,!Custom2;"
					+ "!Custom3;!Custom4;"
				//	+ "!AnniversaryYear,AnniversaryMonth,AnniversaryDay;"
					+ "X!BirthYear,XBirthMonth,XBirthDay;"

				;  // semikolon terminates 'reminderfox.abCard.items' !


	reminderfox.abCard.itemsEU = "// European version;"
					+ "LabelContact;"
						+ "!DisplayName;"
						+ "!LastName,FirstName;"
						+ "!PrimaryEmail,SecondEmail;"

					+ "LabelPhone;"
						+ "!HomePhone,!FaxNumber;"
						+ "!WorkPhone;"
						+ "!CellularNumber;"

					+ "LabelHome;"
						+ "!HomeAddress,HomeAddress2;"
						+ "!HomeZipCode,HomeCity;"
						+ "!HomeCountry,!HomeState;"

					+ "LabelWork;"
						+ "JobTitle;"
						+ "!Company,Department;"
						+ "!WorkAddress,WorkAddress2;"
						+ "!WorkCity,WorkZipCode;"
						+ "!WorkCountry,!WorkState;"

					+ "LabelOther;"
						+ "!Custom1,!Custom2;"
						+ "!Custom3;!Custom4;"
					//	+ "!AnniversaryYear,AnniversaryMonth,AnniversaryDay;"
						+ "X!BirthYear,XBirthMonth,XBirthDay;"

					;  // semikolon terminates 'reminderfox.abCard.items' !

reminderfox.abCard.items = null; // this contain the active cardItem set
reminderfox.abCard.prop = "rf.contacts.";

reminderfox.abCard.errMsg = "addContact2Reminder Warning!";
reminderfox.abCard.errMsg1 = "Item naming missing for:  ";


reminderfox.abCard.personalABURI = 'moz-abmdbdirectory://abook.mab';
reminderfox.abCard.collectedAABURI = 'moz-abmdbdirectory://history.mab';
reminderfox.abCard.selectedABURI = null;
reminderfox.abCard.cDirectory = '';
reminderfox.abCard.cCard = null;
reminderfox.abCard.bundle = document.getElementById("bundle_addressBook");

/**
 *
 * /messenger/addressbook/abCardOverlay.js/
 *
 * function AbEditSelectedCard()
 {
 AbEditCard(GetSelectedCard());
 }
 --> goEditCardDialog(GetSelectedDirectory(), card);
 ondialogaccept="return EditCardOKButton();">
 siehe
 *		function InitEditCard()
 *		--> gEditCard
 */
/**
 * Add a reminder for Contact in TB/AB
 *
 * @param {string} op = Reminder|Copy
 */
reminderfox.abCard.addReminder4Contact = function(op){
	//	--- get the Contact info
	reminderfox.abCard.selectedABURI = GetSelectedDirectory();
	reminderfox.abCard.cDirectory = GetDirectoryFromURI(reminderfox.abCard.selectedABURI).dirName;
	
	if (reminderfox.abCard.cDirectory.isMailList) {
		return;
	} // terminate if on 'List'
	switch (op) {
		case "Reminder":{ // this is to set a reminder from a selected card
			reminderfox.abCard.cCard = GetSelectedCard();
			
			if (reminderfox.abCard.cCard == null) {
				reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.contacts.abcard.single"));
				return;
			}
			// --- setup the reminder -----
			var time = new Date();
			//time.getTime();
			var timeString = reminderfox.date.getTimeString(time);
			var _dateVariableString;
			try {
				_dateVariableString = reminderfox.core.getUnicodePref(reminderfox.core.consts.REMINDER_FOX_PREF + "." + reminderfox.core.consts.LIST_DATE_LABEL);
			} 
			catch (e) {
						}
			var remFoxDate = reminderfox.date.getDateVariable(null, time, _dateVariableString) + "  " + timeString;
			var newDate = new Date();
			newDate.setDate(newDate.getDate() + 1); // default to using tomorrow's date for reminder
			var reminderId = reminderfox.core.generateUniqueReminderId(newDate);
			
			if (reminderfox.msgnr.ab3) { // if TB/AB3 then add an "UUID" element to the card
						// alert ("we are in reminderfox.abCard.addReminder4Contact ... ")
				// reminderfox.abCard.cCard.setProperty("UUID", reminderId);
			}
			var remFoxSummary = "[" + reminderfox.abCard.itemName("LabelContact") + "] " +
			reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "DisplayName");
			var newReminderToBeAdded = new reminderfox.core.ReminderFoxEvent(reminderId, newDate, remFoxSummary);
			newReminderToBeAdded.extraInfo = "X-REMINDERFOX-CONTACT:" +
			reminderfox.abCard.selectedABURI +
			"::" +
			reminderfox.abCard.cDirectory +
			"::" +
			reminderfox.abCard.cCard.displayName;
			var cNotes = '[' + reminderfox.abCard.cDirectory + ']\n';
			var custItems = "";
			var labelStr = "";
			
			// +++++ read  all card-items to be added +++++
			var rmFx_cardItems = reminderfox.abCard.readPref(); // -- get values
			var cardItems = rmFx_cardItems.split(";");
			for (var i = 0; i < cardItems.length; i++) {
				var anyValue = false;
				var currentLine = cardItems[i];
				
				if (cardItems[i].indexOf("Label") != -1) {
					if (cardItems[i].charAt(0) != "X") {
						labelStr = "\n" + reminderfox.abCard.itemName(cardItems[i]) +
						":\n";
					}
				}
				else {
				
					if ((currentLine != "") &&
					(currentLine.substring(0, 2) != "//")) {
						var usAdr = false;
						
						if (currentLine.indexOf("WorkCity,WorkState") != -1 ||
						currentLine.indexOf("HomeCity,HomeState") != -1) usAdr = true;
						var cItems = currentLine.split(",");
						for (var j = 0; j < cItems.length; j++) { /* one item */
							var namString = cItems[j];
							
							//  process  cardItem
							if (namString.charAt(0) == "!") {
								// this needs to fetch the namString
								var iName = namString.substring(1);
							}
							else {
								iName = namString;
							}
							if (iName == "HomeWebPage") iName = "WebPage1";
							if (iName == "WorkWebPage") iName = "WebPage2";
							var iname = iName.substring(0, 1).toLowerCase() + iName.substring(1);
							
							if (iname.charAt(0) != "x") {
								var thisItem = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, iName);
								
								if (iName.indexOf("Custom") != -1) {
								
									if (thisItem != -1 && thisItem != "") {
										cNotes += labelStr + "    " + reminderfox.abCard.itemName(iName) + " : " +
										thisItem;
										anyValue = true;
										labelStr = "";
									}
								}
								else {
								
									if (namString.charAt(0) == "!") {
									
										if (thisItem != -1 && thisItem != "") {
											cNotes += labelStr + "    " + reminderfox.abCard.itemName(iName) + ":\t";
											anyValue = true;
											labelStr = "";
										}
									}
									
									if (thisItem != -1 && thisItem != "") {
									
										if (labelStr != "" && thisItem != "") {
											cNotes += labelStr;
											labelStr = "";
										}
										
										if (anyValue == false) cNotes += "    ";
										cNotes += thisItem;
										
										if (usAdr == false) {
											cNotes += "   ";
										}
										else {
											cNotes += ",  ";
										}
										usAdr = false;
										anyValue = true;
									}
								}
							}
						}
					}
					
					if (anyValue == true) cNotes += "\n";
				}
			}
			newReminderToBeAdded.notes = cNotes;
			
			if (custItems != "") newReminderToBeAdded.notes += "\n" + custItems + "\n";
			// --- add ABcard-items to rmFx-fields ---
			// add address to 'Location' for search with Google Maps
			var workAddr = "";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkAddress");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkAddress2");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkCity");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkAddress");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkState");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkZipCode");
			
			if (w != "") workAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "WorkCountry");
			
			if (w != "") workAddr += w + " ";
			var locAddr = "";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeAddress");
			
			if (w != "") locAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeAddress2");
			
			if (w != "") locAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeCity");
			
			if (w != "") locAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeState");
			
			if (w != "") locAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeZipCode");
			
			if (w != "") locAddr += w + " ";
			var w = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "HomeCountry");
			
			if (w != "") locAddr += w + " ";
			
			if (locAddr == null || locAddr == "") locAddr = workAddr;
			//  .location does NOT accept local chars like  in 'KLN'  ==> so normalize the string
			newReminderToBeAdded.location = reminderfox.abCard.normalizeNameString(locAddr);
			var cItem = reminderfox.abCard.cCard.primaryEmail;
			
			if (cItem != "") newReminderToBeAdded.url = "mailto" + ":" + cItem;
			cItem = reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "Category");
			
			if (cItem != "") newReminderToBeAdded.categories = reminderfox.abCard.cCard.category;
			
			var bYear = (reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "BirthYear"));
			
			if (bYear != "") { // need a year as string, if not skip birthday
				newReminderToBeAdded.summary += '   <' + bYear + '>';
				// set the StartDate for the reminder to the Birthday Month/Day
				var newDate = new Date();
				var month = parseInt(reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "BirthMonth")) - 1;
				newDate.setMonth(month);
				newDate.setDate(parseInt(reminderfox.abCard.cCardItem(reminderfox.abCard.cCard, "BirthDay")));
				newReminderToBeAdded.date = newDate;
				// set 'repeat yearly' and 'allDay'
				newReminderToBeAdded.recurrence.type = 0; //reminderfox.core.consts.RECURRENCE_YEARLY;
				newReminderToBeAdded.allDayEvent = true;
			}
			reminderfox.abCard.writePref();
			//  .... and go to display it .... w 'edit'  to get recurrence + allDay
			var added = reminderfox.core.addReminderHeadlessly(newReminderToBeAdded, true, true /*edit*/);
		}
		case "Copy":{ // copy mailadr of selected cards to clipboard
			//    with mailName <mailadr@xxx.yy>, etc
			var rmFx_Cards = GetSelectedAbCards();
			var xAttendees = "";
			for (var n = 0; n < rmFx_Cards.length; n++) {
				xAttendees += rmFx_Cards[n].lastName + " " + rmFx_Cards[n].firstName +
				"<" +
				rmFx_Cards[n].primaryEmail +
				">,";
			}
			// del last comma
			xAttendees = xAttendees.substring(0, xAttendees.length - 1)
			reminderfox.abCard.abookMini();
			reminderfox.util.copytoClipboard(xAttendees);
			reminderfox.abCard.insertAttendees(xAttendees);
			return;
		}
	} // switch
};

/**
 *   focus on the  'invitation' window
 */
reminderfox.abCard.insertAttendees = function(xAttendees){
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var topWindow = reminderfox.util.getWindow("window:ItemDialog");
	
	try {
		topWindow.focus();
		var attendeeBox = topWindow.document.getElementById("attendees");
		var attendeeText = attendeeBox.value;
		var end0 = attendeeBox.selectionEnd;
		
		if (attendeeText == "" && attendeeText != null) {
			attendeeBox.value = xAttendees;
		}
		else {
			if (attendeeText.charAt(attendeeText.length) != ',') {
				attendeeBox.value = attendeeText + ',' + xAttendees;
			}
			else {
				attendeeBox.value = attendeeText + xAttendees;
			}
		}
		var end = attendeeBox.textLength;
		attendeeBox.setSelectionRange(end);
		topWindow.focus();
	} 
	catch (e) {
		}
};


reminderfox.abCard.abookOpen = function(){
	// first enable textbox for easy pasting
	document.getElementById('attendees').removeAttribute("disabled");
	document.getElementById('inviteEnable').setAttribute("checked", "true");
	
	var topWindow = reminderfox.util.getWindow("mail:addressbook");
	
	if (topWindow) { // if already open bring it to front
		topWindow.focus();
	}
	else {
		var mailApp = reminderfox.util.messengerApp();
		if ((mailApp == null) || (mailApp == "")) {
			reminderfox.util.PromptAlert("Messenger not found!"); // reminderfox.core.getBundle().getString("rf.schedule. $$string$$ "));
			return;
		}
		var go4Process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
		
		try {
			go4Process.init(mailApp);
		} 
		catch (ex) {
				}
		go4Process.run(false, new Array("-addressbook"), 1);
	}
};

reminderfox.abCard.abookMini = function(){
	var topWindow = reminderfox.util.getWindow("mail:addressbook");
	topWindow.minimize();
};


reminderfox.abCard.cCardItem = function(cCard, iName){
	// ---------------- get item Value or set to -1 if invalid "
	
	try {
		if (!reminderfox.msgnr.ab3) {
			iName = iName.substring(0, 1).toLowerCase() + iName.substring(1);
			//!cCard[iName].length;
			
			var rv = (cCard[iName]) ? cCard[iName] : "";
			return rv;
		}
		else {
			var iValue = cCard.getProperty(iName, "");
			return iValue;
		}
		
	} 
	catch (ex) {
		alert(reminderfox.abCard.errMsg + "\n1: " + iName);
		reminderfox.core.logMessageLevel(reminderfox.abCard.errMsg + "\n[" + reminderfox.msgnr.name + "] " +
		reminderfox.abCard.errMsg +
		iName, 2);
		return -1;
	}
};



reminderfox.abCard.itemName = function(namItem){
	/* ---------- access the properties ... if relevant  -------------
	 */
	try {
		// .... access 'address.properties'
		if (namItem == "DisplayName" ||
		namItem == "NickName" ||
		namItem == "PrimaryEmail" ||
		namItem == "SecondEmail" ||
		namItem == "ScreenName") 			
			return reminderfox.abCard.bundle.getString("property" + namItem);
		
		
		if (namItem == "LabelContact" || namItem == "HomeAddress") 			
			return reminderfox.core.getBundle().getString(reminderfox.abCard.prop + namItem);
		
		if (namItem.indexOf("Label") != -1) 			
			return reminderfox.abCard.bundle.getString("heading" + namItem.substring(5));
		
		if (namItem.indexOf("Number") != -1) 			
			return reminderfox.abCard.bundle.getString("property" + namItem.substring(0, namItem.indexOf("N")));
		
		
		// ... access morecols.properties  ... if there else addressbook.p
		if (namItem.indexOf("Custom") != -1) 			
			return reminderfox.abCard.getCustomLabel(namItem);
		
		// ... now no entries ... need to set it here (without 'locale' translation)
		if (namItem.indexOf("Name") != -1) 			
			return namItem;
		
		if (namItem == "JobTitle") 			
			return "Job";
		if (namItem == "Department") 			
			return "Department";
		if (namItem == "Company") 			
			return "Company";
		
		if (namItem == "HomeWebPage" ||
		namItem == "WorkWebPage") 			
			return "WebPage";
		
		if (namItem.indexOf("Address2") != -1) 			
			return "";
		
		//  ... delete 'Phone'  from item-name and return it
		if (namItem.indexOf("Phone") != -1) 			
			return namItem.substring(0, 4);
		
		// ... delete 'Work' or 'Home' from item-name and return it
		if ((namItem.indexOf("Work") != -1) ||
		(namItem.indexOf("Home") != -1)) 			
			return namItem.substring(4);
		
		
	} 
	catch (ex) {
		reminderfox.core.logMessageLevel(reminderfox.abCard.errMsg + "\n[" + reminderfox.msgnr.name + "] " +
		reminderfox.abCard.errMsg1 +
		namItem, 2);
	}
	
	return namItem;
};



reminderfox.abCard.getCustomLabel = function(iName){
	// ---------- work with Custom 1..4 individual entries  -------------
	
	var cLabel = "";
	var moreColsPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	var cLabelid = "morecols." +
	iName.substring(0, 1).toLowerCase() +
	iName.substring(1) + ".label";
	try {
		cLabel = moreColsPrefs.getComplexValue(cLabelid, Components.interfaces.nsISupportsString).data;
	} 
	catch (e) {
		cLabel = "Custom " + iName.substring(6, 7);
	}
	
	return cLabel;
};

reminderfox.abCard.readPref = function(){
	// ------------------------------------------------ READ  PREFS
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var abCardPrefVersion = "US";
	try {
		abCardPrefVersion = prefService.getCharPref("rmFx.abCardItems.version");
	} 
	catch (e) {
		}
	prefService.setCharPref("rmFx.abCardItems.version", abCardPrefVersion);
	try {
		reminderfox.abCard.items = prefService.getComplexValue("rmFx.abCardItems", Components.interfaces.nsISupportsString).data;
	} 
	catch (e) {
		if (abCardPrefVersion == "US") {
			reminderfox.abCard.items = reminderfox.abCard.itemsUS; // set to US default
			prefService.setCharPref("rmFx.abCardItems.version", "US");
		}
		if (abCardPrefVersion == "EU") {
			reminderfox.abCard.items = reminderfox.abCard.itemsEU; // set to EU default
			prefService.setCharPref("rmFx.abCardItems.version", "EU");
		}
	}
	
	return reminderfox.abCard.items;
};


reminderfox.abCard.writePref = function(){
	// ------------------------------------------------ WRITE  PREFS
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var abCardPrefVersion = "US";
	try {
		abCardPrefVersion = prefService.getCharPref("rmFx.abCardItems.version");
	} 
	catch (e) {
		prefService.setCharPref("rmFx.abCardItems.version", abCardPrefVersion);
	}
	prefService.setCharPref("rmFx.abCardItems", reminderfox.abCard.items);
};


/**
 * From the reminderlist open the associated TB/AB card
 <br>  This requires the contact was added before from the TB/AB card or list selection
 <br>  The reminder has these paramters to define the card:
 <br>  -  reminder.url    {mail address} foo@nowhere.moc
 <br>  -  reminder.extraInfo with 'X-REMINDERFOX-CONTACT:{directory}::{AB title}::{DisplayName})'
 <br>  ++2todo REWORK: with getting a UUID for the card/contact;
 *
 <br>  @see bug https://bugzilla.mozilla.org/show_bug.cgi?id=444093
 *
 * @param event -- the selected reminder or todo (only one allowed!)
 * @return opens the TB/AB card
 * @
 */
reminderfox.abCard.openABcard = function(event){
	//------------------------------------------------------------------------------
	var selectedEvents;
	
	if (event.currentTarget.id == "treechildren-contextmenu-reminder-openABcard") {
		selectedEvents = getAllSelectedReminders(); // from 'reminder list' context menu
	}
	if (event.currentTarget.id == "treechildren-contextmenu-todo-openABcard") {
		selectedEvents = getAllSelectedTodos(); // from 'reminder list' context menu
	}
	
	if (selectedEvents.length != 1) {
		reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.contacts.abcard.single"));
		return;
	}
	/*----
	 let allAddressBooks = abManager.directories;
	 while (allAddressBooks.hasMoreElements()) {
	 let addressBook = allAddressBooks.getNext();
	 if (addressBook instanceof Components.interfaces.nsIAbDirectory) {
	 reminderfox.util.dump2Console('AB', "AB : " + abManager.getDirectory(addressBook.URI).URI
	 + " " + abManager.getDirectory(addressBook.URI).dirName);
	 //reminderFox: AB : moz-abmdbdirectory://abook.mab
	 //reminderFox: AB : moz-abmdbdirectory://abook-1.mab
	 //reminderFox: AB : moz-abmdbdirectory://history.mab
	 }
	 }
	 --------- */
	// X-REMINDERFOX-CONTACT:moz-abmdbdirectory://abook.mab::Personal Address Book::Werny Nigger\\nDTSTAMP:20090722T114039
	
	var abManager = Components.classes["@mozilla.org/abmanager;1"].getService(Components.interfaces.nsIAbManager);
	
	var exPos = selectedEvents[0].extraInfo.indexOf("X-REMINDERFOX-CONTACT:");
	
	if (exPos != -1) {
	
		var contactInfo = selectedEvents[0].extraInfo.substring(22);
		var contactStr = contactInfo.split("\\n")[0];
		var contactDetails = contactStr.split("::");
		var abURI = contactDetails[0];
		
		if (selectedEvents[0].url != null) {
			var thisMailAdr = selectedEvents[0].url.substring(7);
			var thisCard = abManager.getDirectory(abURI).cardForEmailAddress(thisMailAdr);
		}
		else {
			// search for element as stored with "DisplayName"
			var thisCard = abManager.getDirectory(abURI).getCardFromProperty("DisplayName", contactDetails[2], false);
		}
		
		if (thisCard != null) window.openDialog("chrome://messenger/content/addressbook/abEditCardDialog.xul", "", "chrome,resizable=no,modal,titlebar,centerscreen", {
			abURI: abURI,
			card: thisCard
		});
	}
};

/**
 * imported from "Duplicate Contact Manager" by   Marian Steinbach, 2006
 * normalizeNameString
 <br>
 * Strips some characters from a name so that different spellings (e.g. with and
 * without accents, can be compared. Works case insensitive.
 *
 * @param	String		the string to be normalized
 * @return	String		normalized version of the string
 */
reminderfox.abCard.normalizeNameString = function(str){
	//------------------------------------------------------------------------------
	// remove punctiation
	//str = str.replace(/[\"\-\_\'\.\:\,\;\&\+]+/g, '');
	
	// replace funny letters
	str = str.replace(/[ÃÃÃÃÃ¨Ã©ÃªÃ«ÄÄÄÄÄÄÄÄÄÄ]/g, 'e');
	str = str.replace(/[ÃÃÃÃÃÃ¢Ã¡Ã Ã£Ã¥ÄÄÄÄÄÄÇºÇ»]/g, 'a');
	str = str.replace(/[ÃÃÃÃÃ¬Ã­Ã®Ã¯Ä¨Ä©ÄªÄ«Ä¬Ä­Ä®Ä¯Ä°Ä±]/g, 'i');
	str = str.replace(/[ÃÃÃÃÃÃ²Ã³Ã´ÃµÃ¸ÅÅÅÅÅÅÇ¾Ç¿]/g, 'o');
	str = str.replace(/[ÃÃÃÃ¹ÃºÃ»Å¨Å©ÅªÅ«Å¬Å­Å®Å¯Å°Å±Å²Å³Æ¡Æ¯Æ°]/g, 'u');
	str = str.replace(/[ÃÃ½Ã¿Å¶Å·Å¸]/g, 'y');
	
	str = str.replace(/[ÃÃ§ÄÄÄÄÄÄÄÄ]/g, 'c');
	str = str.replace(/[ÃÃ°ÄÄÄ]/g, 'd');
	str = str.replace(/[ÄÄÄÄÄ Ä¡Ä¢Ä£]/g, 'g');
	str = str.replace(/[Ä¤Ä¥Ä¦Ä§]/g, 'h');
	str = str.replace(/[Ä´Äµ]/g, 'j');
	str = str.replace(/[Ä¶Ä·Ä¸]/g, 'k');
	str = str.replace(/[Ä¹ÄºÄ»Ä¼Ä¿ÅÅÅ]/g, 'l');
	str = str.replace(/[ÃÃ±ÅÅÅÅÅÅÅÅÅ]/g, 'n');
	str = str.replace(/[ÅÅÅÅÅÅ]/g, 'r');
	str = str.replace(/[ÅÅÅÅÅÅÅ Å¡]/g, 's');
	str = str.replace(/[Å¢Å£Å¤Å¥Å¦Å§]/g, 't');
	str = str.replace(/[Å´Åµ]/g, 'w');
	str = str.replace(/[Å¹ÅºÅ»Å¼Å½Å¾]/g, 'z');
	
	// replace ligatures
	str = str.replace(/[ÃÃÃ¤Ã¦Ç¼Ç½]/g, 'ae');
	str = str.replace(/[ÃÃ¶ÅÅ]/g, 'oe');
	str = str.replace(/[ÃÃ¼]/g, 'ue');
	str = str.replace(/[Ã]/g, 'ss');
	str = str.replace(/[Ä²Ä³]/g, 'ij');
	
	// remove single letters (like initials)
	/*	str = str.replace(/ [A-Za-z0-9] /g, ' ');
	 str = str.replace(/^[A-Za-z0-9] /g, '');
	 str = str.replace(/ [A-Za-z0-9]$/g, '');
	 */
	// remove multiple white spaces
	str = str.replace(/[\s]{2,}/, ' ');
	
	// remove leading and trailing space
	str = str.replace(/[\s]{2,}/g, ' ');
	str = str.replace(/^[\s]+/, '');
	str = str.replace(/[\s]+$/, '');
	
	str = str.toLowerCase();
	return str;
}
