/**
 * rmFxMail.js
 *
 * @since
 * @since 2009-12-17  EndOfSupport for TB1.x
 * @since 2008-08-04  Open Msg with msgID also with FX (non-mail apps)
 * @since 2008-04-14	tagging	- add/delete 'ical-*' tags for messages containing iCal data
 * @since 2008-01-19	add TB-priority handling
 * @since 2006-11-11	mod for TB1.5/label and TB2.0/tag

 * @see
 *  MessageID-Finder for Mozilla 'messageidfinder-2.0.0.xpi' by markushossner_AT_gmx_DOT_de and
 *	'reminderfox-0.9.6.xpi' by Daniel Lee, Tom Mutdosch
 */


// if(!reminderfox) var reminderfox={};
if(!reminderfox.mail)		reminderfox.mail = {};


reminderfox.mail.currentSummary = null;
reminderfox.mail.ReferenceID = "@" + "reminderfox"
reminderfox.mail.FCC ="";
reminderfox.mail.cmdID = null;
reminderfox.mail.cmdString = "";
reminderfox.mail.deleteSendFileOnCompletion = true;



/**
* GetSelectedMessages for different TB/SM/PB versions
*/
reminderfox.mail.getSelectedMessages = function() {
	reminderfox.msgnr.whichMessenger();
	var rv;
	
	if ((reminderfox.msgnr.name == "TB3") || (reminderfox.msgnr.name == "SM2")) {
		var mailWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
			.QueryInterface(Components.interfaces.nsIWindowMediator)
			.getMostRecentWindow("mail:3pane");
		if (mailWindow) {
			rv = mailWindow.gFolderDisplay.selectedMessageUris;
		}
	} else {	// valid for all other versions
		rv = GetSelectedMessages();
	}
	return rv;
}

///////// startup TB/SM/PB with different operations   /////////////////////////
/**
  *  Work with rmFx_cmdLineHandler to support starting 'messenger' (TB/SM/PB)
  *  with start option:
  *
  *	@call  'messenger'.exe -reminderFox {remoteID}				-msgString {details for op}
  *	@call  'messenger'.exe -reminderFox UID:refID				-msgString {file path}
  *	@call  'messenger'.exe -reminderFox COMPOSE:subject		-msgString {compose parameters}
  *	@call  'messenger'.exe -reminderFox msgID:finalMessageId -msgString {subject info}
 */
reminderfox.mail.startupwMsgId = function() {
//------------------------------------------------------------------------------
	var startMsg = window.arguments[0].split("|.|");
	reminderfox.mail.cmdID	= startMsg[0];
	reminderfox.mail.cmdString = startMsg[1];

	//gWTEST Darwin	---------<<< ---------------

	var logString = (" startupwMsgId 'remote start': "
			+ "\n reminderfox.mail.cmdID: " + reminderfox.mail.cmdID
			+ "\n reminderfox.mail.cmdString: " + reminderfox.mail.cmdString);

	Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService)
			.logStringMessage("reminderFox: " + logString);
	// ------------>>> ----------------

	var cDate = new Date();
	var msgLog = " ** Remote access **  " + reminderfox.mail.cmdID + " at: " + cDate;

	reminderfox.msgnr.whichMessenger();

	// -reminderFox UID:refID -msgString mailFile.path
	if (reminderfox.mail.cmdID.indexOf('UID:') > -1) {
		document.title = "Remote send message";	// reminderfox.core.getBundle().getString("rf.mail.remote.sendmsg");

		document.getElementById('rmFx_msg1').setAttribute("value", reminderfox.mail.cmdID);
		document.getElementById('rmFx_msg2').setAttribute("value", "");
		setTimeout( reminderfox.msgnr.sendwUIDgo, 1000 );

	// -reminderFox COMPOSE:subject -msgString {compose parameters}
	} else  if (reminderfox.mail.cmdID.indexOf('COMPOSE:') > -1) {
		document.title = "Remote compose message";  // reminderfox.core.getBundle().getString("rf.mail.remote.composemsg");

		var msgString = unescape(reminderfox.mail.cmdString).split(";\n;");
		var subject	= msgString[0].substring(8);

		document.getElementById('rmFx_msg1').setAttribute("value", "Subject: " + subject);
		document.getElementById('rmFx_msg2').setAttribute("value", "");
		setTimeout( reminderfox.msgnr.composeMSGgo, 1000 );

	// -reminderFox msgID:finalMessageId -msgString {subject info}
	} else  if (reminderfox.mail.cmdID.indexOf('msgID:') > -1) {
		document.title = "Remote open message";	//	reminderfox.core.getBundle().getString("rf.mail.remote.openmsg");

		document.getElementById('rmFx_msg1').setAttribute("value", unescape(reminderfox.mail.cmdString));
		document.getElementById('rmFx_msg2').setAttribute("value", reminderfox.mail.cmdID);
		setTimeout(reminderfox.mail.retryMsgIdDelayed, 1000 );

	} else {
		var loggedAt = "[[" + Components.stack.caller.filename + "  # "
			+ Components.stack.caller.lineNumber + "]]";
		alert ("ReminderFox call error: " +loggedAt)
		return;
	}
}

/**
 *  find message with MsgID ////////////////////////////
 *
 */
reminderfox.mail.retryMsgIdDelayed = function () {
	var msgHdr = reminderfox.messageId.finder(reminderfox.mail.cmdID.substring(6));
	if (msgHdr) {
		window.close();
	} else  { // 'reminderfox.messageId.finder' with TB startup will fail because
	//  folder structure not build already
	//  if it fails  -->>  aks for 'retry'
		document.getElementById('msgIDnotFound').setAttribute("hidden", "false");
		document.getElementById('retryMsgId').setAttribute("disabled", "false");
		sizeToContent();
		window.focus();
	}
}

reminderfox.mail.retryMsgId = function () {

	if (reminderfox.mail.cmdID.indexOf('UID:') > -1) {
		reminderfox.msgnr.sendwUIDgo();
		window.close();
	} else {
		var msgHdr = reminderfox.messageId.finder(reminderfox.mail.cmdID);
		if (msgHdr) {
			window.close();
		}
	}
}


reminderfox.mail.doShowMail = function () {
	var currentReminder = getReminderForSelectedItem( );
	if (currentReminder.messageID != null) {
		reminderfox.mail.openByMessageID(currentReminder);
	}
	else if ( reminderFox_isGMailEvent(currentReminder) ) {
		reminderFox_openURL(currentReminder.url);
		reminderFox_focusBrowser();
	}
};

reminderfox.mail.doShowMailTodo = function () {
	var currentTodo = getTodoForSelectedItem();
	if ( currentTodo.messageID != null) {
		reminderfox.mail.openByMessageID(currentTodo);
	}
	else if (reminderfox.core.isGMailEvent(currentTodo)) {
		reminderfox.core.openURL(currentTodo.url);
		reminderfox.core.focusBrowser();
	}
};

reminderfox.mail.doShowMailShortcut = function () {
	if (isReminderTabSelected()) {
		reminderfox.mail.doShowMail();
	}
	else {
		reminderfox.mail.doShowMailTodo();
	}
};

/**
 * open/displayMail
 *
<br>  retrieve and display this reminder's associated email in Thunderbird
 */
reminderfox.mail.openByMessageID = function (currentReminder){
	var finalMessageId = reminderfox.mail.finalMessageId(currentReminder.messageID);

	reminderfox.mail.currentSummary = currentReminder.summary;

	// if using Firefox, this starts (Thunderbird) Messenger App ...
	// using a specific 'commandLine' Handler

	if(!("@mozilla.org/messenger;1" in Components.classes)) {

		var mailApp = reminderfox.util.messengerApp();
		if ((mailApp == null) || (mailApp == ""))  {
			reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.messenger.notfound"));
				return;
		}

		var args = new Array();
		args [0] = "-reminderFox";
		args [1] = "msgID:" + finalMessageId;
		args [2] = "-msgString";
		args [3] = escape(reminderfox.mail.currentSummary);			// currentReminder.summary;

		var go4Process = Components.classes["@mozilla.org/process/util;1"]
									.createInstance(Components.interfaces.nsIProcess);

		try {
			go4Process.init(mailApp);
		} catch (ex) {}
		go4Process.run(false, args, args.length);

		return;		// FX schedules TB with msgID:messageID -msgString reminderfox.mail.currentSummary
	}

	if (finalMessageId !="" ) {
		var msg = reminderfox.messageId.finder(finalMessageId);

		if (!msg) {
			var strMsgIdNotFound = reminderfox.core.getBundle().getString("rf.add.mail.messageIdNotFound.message") +
					"\n" + reminderfox.mail.currentSummary  +
					"\n(Message-ID: " + finalMessageId +")";
			reminderfox.util.PromptAlert(strMsgIdNotFound);
			window.setCursor("auto");
		}
	}
}

reminderfox.mail.finalMessageId = function (messageId){
	var midleft = (messageId.toLowerCase()).search("<");
	var finalMessageId;
	if (midleft == -1)
			finalMessageId = "";
	else {
		var midRight = (messageId.substring(midleft)).search(">");
		finalMessageId =  messageId.substring(midleft + 1, midRight );
	}
	return finalMessageId;
};


	/**
	* Clear the 'Reminder' tag from a message
	*
	* @note	this function only works in messenger/ThunderBird
	* @param messageId
	*/
reminderfox.mail.clearLabelByMessageID = function (messageId){

	var finalMessageId = reminderfox.mail.finalMessageId(messageId)
	if (finalMessageId != "" )  reminderfox.messageId.openMessageById( finalMessageId,
			false /*msgOpen*/, 0 /*labelTag*/, false /*opTag*/);
};


///////////////////// .mail. ////////////////////////////////////////////////


//  ------------- GET TODO(s) ------------------------------
/**
 *   Get all user selected Todos on a displayed ReminderFox List
 *   @return  {object} todoArrayArray
 */
reminderfox.mail.getSelectedTodos = function () {

	var tabList = document.getElementById("tabList");
	var tab = tabList.selectedItem;
	var tabLabel =  tab.label;

	var todosToBeSend = getAllSelectedTodos();

	if (todosToBeSend.length == 0) return null;
	
	//  todosToBeSend[0].extraInfo
	for (var i = 0; i < todosToBeSend.length; i++) {
		if (todosToBeSend[i].extraInfo == null) {
			todosToBeSend[i].extraInfo = REMINDERFOX_EXTENDED + "LISTID:" + tabLabel;
		} else {
			if (todosToBeSend[i].extraInfo.indexOf(reminderfox.core.consts.REMINDER_FOX_EXTENDED + "LISTID") == -1) {
				todosToBeSend[i].extraInfo += "\\n" + reminderfox.core.consts.REMINDER_FOX_EXTENDED + "LISTID:" + tabLabel;
			}
		}
	}
	var todoArrayArray = new Array();
	todoArrayArray[0] = todosToBeSend;

	return todoArrayArray;
};



//  ------------- SEND / EXPORT  iCal ------------------------------
/**
 *  Send/export one or more 'reminder(s)' as they are
 *
 * @param selcReminders
 * @param organizer
 * @param mode				if 'xExport' stores reminders to file
 * @param reminderTyp		'reminder' | 'todo'
 *
 */
reminderfox.mail.sendAsItIs = function (selcReminders, organizer, mode, reminderTyp) {
	var methodTyp = "ICS";
	var attendees = null;

	if (mode == 'xExport') {	// generate an ICS file here

		var nReminders = selcReminders.length;
		if (reminderTyp == 'todo') {
				var iCalString = reminderfox.core.constructReminderOutput( "", selcReminders, true, true, "PUBLISH" );
				var nReminders = selcReminders[0].length;
		}  else {
				var iCalString = reminderfox.core.constructReminderOutput( selcReminders, "", true, true, "PUBLISH" );
				var nReminders = selcReminders.length;
		}
		var exportFile = reminderfox.core.consts.reminderFox_prefsBranch.getCharPref("exportEventsFile");

		reminderfox.util.dump2Console ('Darwin', "exportReminders to File	>>" + exportFile + "<<  "
					+ " #of reminders:" + nReminders);			//gWTEST darwin

		var iCalToEmailFile = reminderfox.util.makeMsgFile (reminderfox.util.encodeUTF8(iCalString), exportFile);
		if (iCalToEmailFile == null) {
				reminderfox.util.PromptAlert("Export failed. File '" + exportFile + "' path not valid!");
		}  else {
			// write status
			reminderfox.core.statusSet(reminderTyp + " " + "exported: " + nReminders + " to file: " + exportFile)
		}
		return;
	}
	reminderfox.mail.sendEventNow(selcReminders, "", 'ICS' /*methodTyp*/, organizer, attendees, reminderTyp);
};


/**
 * Preparing the message content and passing to the send or compose mail function
 *
 * @param reminderToBeSend passed as array!!
 * @param todosToBeSend	passed as array!!
 * @param methodTyp		'PUBLISH' | 'REQUEST' | 'REPLY' | 'ICS' (for sending 'view')
 * @param fromAddress
 * @param attendees
 * @param selectedTyp		'invite' = send one event as invitation | 'info' = send one/more event
 * @return
 */
reminderfox.mail.sendEventNow = function (reminderToBeSend, todosToBeSend, methodTyp, fromAddress, attendees, selectedTyp) {

	var statusMsg = "";
	if ((fromAddress != "") && (fromAddress != null)) {
		statusMsg += reminderfox.core.getBundle().getString("rf.mail.ical.sendby")
					+ " " + fromAddress;
	}  else {
		statusMsg += reminderfox.core.getBundle().getString("rf.mail.ical.send")  + " ";		// "Sending"
	}
	statusMsg += " " + reminderfox.core.getBundle().getString("rf.mail.ical.sending");
	reminderfox.core.statusSet (statusMsg);

	var footer = "  " + "______________________________________________________\n"
						+ reminderfox.core.getBundle().getString("rf.mail.ical.send.body");

	// --- setup parameters for message -----------------
	var eMailSubject ="";

	if (methodTyp == "ICS") {
		eMailSubject = "[ics]  ";
	}
	if (methodTyp == "PUBLISH") {
		eMailSubject = "[iCal]  " + methodTyp + ": ";	// $$$locale  iCal PUBLISH
	}

	if ((reminderToBeSend != null) && (reminderToBeSend != "")) {
		var uid = reminderToBeSend[0].id;
		var extraInfo = reminderfox.core.extraInfoArray(reminderToBeSend[0]);

		if (selectedTyp == 'reminder') { methodTyp = "PUBLISH"; }
		var iCalString = reminderfox.core.constructReminderOutput( reminderToBeSend, "", true, true, methodTyp );
	}

	if ((todosToBeSend != null) && (todosToBeSend != "")) {
		var uid = todosToBeSend[0][0].id;
		var extraInfo = "";
		if (selectedTyp == 'todo') { methodTyp = "PUBLISH"; }
		var iCalString = reminderfox.core.constructReminderOutput( "", todosToBeSend, true, true, methodTyp );
	}


	if (methodTyp == 'REQUEST' ) {
		eMailSubject = "[iCal]  " + methodTyp + ": ";  //$$$locale  iCal eg. REQUEST
		selectedTyp = 'invite';
	}
	if (methodTyp == 'REPLY') {
		eMailSubject = "[iCal]  ";
		selectedTyp = 'invite';

		var xAtt =reminderfox.core.extraInfoArray(reminderToBeSend[0]);
		var Item = "ATTENDEE";
		var attPart="";
		if (xAtt != null) {
			if (xAtt.length > -1) {
				for (var n =0; n < xAtt.length; n++) {
					if (xAtt[n].indexOf( Item )  == 0) {
						var fnd =  xAtt[n].indexOf("PARTSTAT=");
						if (fnd != -1) {
							var attPart = xAtt[n].substring(fnd+9);
							fnd = attPart.indexOf(";");
							if (fnd == -1) {attPart.indexOf(":")};
							var attPart = attPart.substring(0,fnd);
						}
					}
				}
			}
		}
		eMailSubject +=  attPart  + ": ";		//$$$locale	iCal eg. ACCEPTED / DECLINED
	}

	////////////////// 'invite' was selected ////////////////////////////////////
	// sending without extra compose
	if (selectedTyp == 'invite') {
		eMailSubject += reminderToBeSend[0].summary
				+ " / " + reminderfox.core.getBundle().getString("rf.schedule.statusOf")
				+ " " + reminderfox.date.parseDateTimes(reminderfox.core.extraInfo(extraInfo,"DTSTAMP"))
				+ " [#" + reminderfox.core.extraInfo(extraInfo,"SEQUENCE") +"]";


//  " U+00BB,   " U+00AB
		var body  = "*" + reminderfox.core.getBundle().getString("rf.mail.ical.send.subject.invitation")
			+ '*  "' + reminderToBeSend[0].summary  + '"'
			+ "\n" + reminderfox.core.getBundle().getString("rf.mail.ical.send.sentBy") + "  " + fromAddress + "\n";

		// setup for different invitation items ....
			function addBody (option, optText) {
				return ((option == null) || (option == ""))
					? ""
					: "\n" + optText + option;
			}
		var priority = reminderToBeSend[0].priority;
		var priorityStr = (priority == 1)
			? reminderfox.core.getBundle().getString("rf.add.mail.message.priority")
			: "";

		body += addBody (priorityStr, "*" + reminderfox.core.getBundle().getString("rf.add.mail.message.priority.label")+ "*  ");
		body += addBody (reminderToBeSend[0].location, "*" + reminderfox.core.getBundle().getString("rf.mail.ical.send.location") + "* ");
		body += addBody (reminderToBeSend[0].url, "*" + reminderfox.core.getBundle().getString("rf.add.reminders.tooltip.url") + "* ");
		body += addBody (reminderToBeSend[0].notes, "\n*" + reminderfox.core.getBundle().getString("rf.add.mail.message.notes")
										+"* ___________________________ \n");

		/** ---------- sending without extra compose --------------------------**/
		var tmpMsgFile =  reminderfox.msgnr.FileCreate(
										eMailSubject,
										fromAddress,
										attendees,
										priority,
										body,
										footer,
										uid,
										iCalString, methodTyp);

		reminderfox.msgnr.FileSend (eMailSubject,
								fromAddress,
								attendees,
								priority,
								tmpMsgFile,
								uid);

		reminderfox.core.statusSet (reminderfox.core.getBundle().getString("rf.mail.ical.sendby") + " " + fromAddress);		//  "Send by"
		return;
	}


	/////////// 'reminder' or 'todo' has been selected /////////////
	//  go for compose
	//	one event: just take the reminder.summary as 'subject'
	//	no ATTENDEES (toAddress) ... have to add with 'composemessage'

	// prepare 'body' and 'subject' of message

	var body  = reminderfox.core.getBundle().getString("rf.add.mail.message.body") + "\n";

	if ((fromAddress != "") && (fromAddress != null)) {
		body  +=  reminderfox.core.getBundle().getString("rf.mail.ical.send.sentBy")
				+ "  " + fromAddress +"\n";
	}

	var _subject = "";
	if (selectedTyp == 'todo') {
		if (todosToBeSend[0].length == 0) {
			statusMsg = reminderfox.core.getBundle().getString("rf.mail.ical.noitems");
			reminderfox.core.statusSet (statusMsg);
			return;  // no todo's selected
		}
		if (todosToBeSend[0].length == 1) {
			_subject = todosToBeSend[0][0].summary
		} else {
			_subject = todosToBeSend[0].length;
		}
	}
	if (selectedTyp == 'reminder') {
		if (reminderToBeSend.length == 0) {
			statusMsg = reminderfox.core.getBundle().getString("rf.mail.ical.noitems"); //"No items to be send."
			reminderfox.core.statusSet (statusMsg);
			return;} // no events selected
		if (reminderToBeSend.length == 1) {
			_subject = reminderToBeSend[0].summary
		} else {
			_subject = reminderToBeSend.length;
		}
	}
	var msgInfo = reminderfox.core.getBundle().getString("rf.schedule.event.send." + selectedTyp)
			+ " :  " + _subject;

	// var viewLabel;
	// (rmFxViewLabel != "")
	//		? viewLabel=(" [" + reminderfox.core.getBundle().getString("rf.views.name") + ": " + rmFxViewLabel + "] : ")
	//		: viewLabel=(" : ");
	// body  += selectedTyp.toUpperCase() + viewLabel + _subject + "\n\n";
	body  += msgInfo + "\n\n";

	eMailSubject += msgInfo;


	// ---------- compose ------------------------------------------------
	var iCalFile =	reminderfox.core.getReminderStoreFile();
	iCalFile.leafName = "reminderfoxEvents.ics";

	reminderfox.util.dump2Console ('Darwin', "msg Compose iCalToEmailFile	>>" +iCalFile.path+ "<<");			//gWTEST darwin

	var iCalToEmailFile = reminderfox.util.makeMsgFile (reminderfox.util.encodeUTF8(iCalString), iCalFile.path);
	if (iCalToEmailFile == null) {
		reminderfox.util.PromptAlert("Compose failed. File '" + iCalFile.path + "' path not valid!");
		return;
	}

	reminderfox.msgnr.Compose(eMailSubject, fromAddress,  attendees,
		priority, body, footer, uid, iCalToEmailFile, methodTyp);

	reminderfox.core.statusSet (reminderfox.core.getBundle().getString("rf.add.mail.message.compose")) /*"Compose message"*/
};


//  --- reminderfox.mail.folderListener  ----------------------------------------------- ---
/**
 *  folder listener used with	SEND++
 */
reminderfox.mail.folderListener = {
		OnItemEvent: function(aFolder, event) {
		},
		OnItemAdded: function(parentItem, item) {
		},
		OnItemIntPropertyChanged: function(aFolder, aProperty, aOldValue, aNewValue) {

		var folderURI  = (reminderfox.msgnr.name != "PB")
				?  aFolder.URI
				:	aFolder.QueryInterface(Components.interfaces.nsIRDFResource).Value;

			var msg = "FolderListener: OnItemIntPropertyChanged: reminderfox.mail.FCC:" + reminderfox.mail.FCC
					+ "\naFolder.URI: " + folderURI
					+ "\n" + aProperty.toString() + "  old: " + aOldValue + "  new: " + aNewValue

			if ((aProperty.toString() == "FolderSize") && (reminderfox.mail.FCC == folderURI)) {
				reminderfox.util.dump2Console ('FolderListener', msg)

				if ( aOldValue != aNewValue) {
				var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance()
								.QueryInterface(Components.interfaces.nsIMessenger);

				var msgUri = reminderfox.messageId.getMsgFolderFromUri(reminderfox.mail.FCC).baseMessageURI + "#" + aOldValue;
				var msgHeader = messenger.messageServiceFromURI(msgUri).messageURIToMsgHdr(msgUri);
				var messageId =  msgHeader.messageId;
				var lastReminder = reminderfox.core.lastEvent;

				// reset the 'send folder' and Listener to process only once
				reminderfox.mail.FCC = "";
				reminderfox.mail.setFolderListener("remove");

				setTimeout(reminderfox.tagging.msg, 100, 'Reminderfox' /*tagName*/, true /*addKey*/,  "#993399", msgHeader);

				// now update the "lastReminder"  with the ".messageID"
				var activeReminders = reminderfox.core.getReminderEvents();

				for ( var i = 0; i < activeReminders.length; i++ ) {
					if (activeReminders[i].id == lastReminder.id ) {
						msg =  (" === found === : " + activeReminders[i].summary);
						reminderfox.util.dump2Console ('FolderListener', msg);

						lastReminder.messageID ="<" + messageId.replace(new RegExp(/\"/g),"") + ">";

						reminderfox.core.removeElement(activeReminders, i);
						reminderfox.core.insertIntoArray(activeReminders, lastReminder, i);
						reminderfox.core.writeOutRemindersAndTodos(false);	// isExport
					}
				}
			}
		}
	}
}

reminderfox.mail.setFolderListener = function (mode) {
	const mailSessionContractID = "@mozilla.org/messenger/services/session;1";
	const nsIMsgMailSession = Components.interfaces.nsIMsgMailSession;
	var mailSession = Components.classes[mailSessionContractID].getService(nsIMsgMailSession);
	var nsIFolderListener = Components.interfaces.nsIFolderListener;

	if (mode == "add") {
		mailSession.AddFolderListener(reminderfox.mail.folderListener, nsIFolderListener.intPropertyChanged);
	}
	if (mode == "remove") {
		mailSession.RemoveFolderListener(reminderfox.mail.folderListener);
	}
}


///////////////////// .mail. \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\




/**
 * MessageID features
 * based on: MessageID-Finder for Mozilla by
 *
 * Markus Hossner - markushossner@gmx.de
 */

if(!reminderfox.messageId) reminderfox.messageId = {

	pmpB : 0,		//Boolean
	pmpN : 1,		//Integer
	pmpS : 2,		//Char
	
	prefRead : false,
	accountURIs : new Array(),
	msgWindow : null,
	
	
	finder : function (strmessageid) {
	
		strmessageid = this.extractID(strmessageid);
	
		var msgHdr = this.openMessageById(strmessageid,true);
		return msgHdr;
	},
	
	
	getMsgWindow : function () {
		if ( this.msgWindow == null ) {
			this.msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"].
					createInstance(Components.interfaces.nsIMsgWindow);
		}
		return this.msgWindow;
	},
	
	
	extractID : function (strmessageid) {
		var midParts = strmessageid.replace(/^<|>$/g, "").split(":");
	
		switch (midParts.length) {
			case 1:
					strmessageid = strmessageid;
					break;
	
			case 2:
					if (midParts[0] == "news" || midParts[0] == "nntp") {
						strmessageid = midParts[1].replace(/^\/\/.*?\// ,"");
					} else if (midParts[0] == "mailto") {
						strmessageid = midParts[1];
					}
					break;
	
			case 3:
					strmessageid = midParts[2].replace(/^.+?\// ,"");
					break;
	
			default:
					strmessageid = "";
					break;
		}
		return strmessageid;
	},
	
	
		/**
		* Message with matching 'messageid' will be processed with tag 'labelTag'
		* based on option 'msgOpen'.
		* If 'msgOpen' true the message will be opened.
		*
	<p>  *  Message is labeled/tagged with optional parameter 'labelTag'
	<ul> *		TB1.5
	<br> *			labelTag = 0 noLabel	=1 ... =5  see Label Options with Pull-Down Menue
	<br> *			opTag = not used
	</ul>*
	<ul> *		TB2.x / TB3.x / SM2 / PB
	<br> *			labelTag = string eg:ReminderFox
	<br> *			opTag = true: add Tag;  false: remove Tag
	</ul>*
		*  @since 2009-04 :
		*	messages in Template and Draft folders are not opened, but
		*	the folder is selected
		*
		*  @since 2009-07
		*	Postbox support .. needs special handling for open folder/message
		*
		* @note
		*	TB3/SM2 and PB need to select message row in folder
		*
		*	@param messageId
		*	@param msgOpen - true: opens in new window
		*	@param labelTag -
		*	@param opTag - true: adds, false: deletes the tag
		*/
	openMessageById : function (messageId, msgOpen, labelTag, opTag) {
	
		reminderfox.msgnr.whichMessenger();
		this.addNewsServers();
		window.setCursor("wait");
	
		var msgHdr = this.searchMessageLocally(messageId);
	
		window.setCursor("auto");
	
		if (msgHdr) {
			var folder = msgHdr.folder;
			var folderUri = folder.URI;
			var messageUri = folder.getUriForMsg(msgHdr);
	
			var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
															.getService(Components.interfaces.nsIWindowMediator);
			var winId = windowManager.getMostRecentWindow("mail:3pane");
	
	
			if (reminderfox.msgnr.name == "TB3") {	//TB3
				winId.focus();
				winId.document.getElementById('tabmail').openTab("folder",
					{folder: msgHdr.folder, msgHdr:msgHdr, messagePaneVisible:true } );
			}
	
			if (reminderfox.msgnr.name == "PB") {				// PB
	
				winId.focus();
				winId.MsgOpenNewTabForFolder(folderUri, msgHdr.messageKey /*key*/, false /*aBackground*/)
			}
	
	
			if (reminderfox.msgnr.name == "SM2") {
	
				var aTabShowFolderPane  = 1 << 0;
				var aTabShowMessagePane = 1 << 1;
				var aTabShowThreadPane  = 1 << 2;
	
				var aTabModeFolder = aTabShowMessagePane;
	
				if (!winId) {
					winId = window.openDialog("chrome://messenger/content/", "",
						"all,dialog=no");
	
					winId = windowManager.getMostRecentWindow("mail:3pane");
				}
	
				winId.focus();
				winId.document.getElementById('tabmail').openTab("3pane",
					aTabModeFolder, folderUri, msgHdr);
			}
	
			// select message in the mail index
			if (reminderfox.msgnr.name == "TB2") {			//TB2
				// --- if folderUri has '/Template' or '/Drafts' it will not open the message
				var xShow = ((folderUri.indexOf("/Templates") == -1) && (folderUri.indexOf("/Drafts") == -1)) ;
	
				// open the message in a new window
				if ((msgOpen) && (xShow)){
						var folder = this.getMsgFolderFromUri(folderUri);
						var messageUri = folder.getUriForMsg(msgHdr);
	
						window.openDialog("chrome://messenger/content/messageWindow.xul", "_blank",
												"all,chrome,dialog=no,status,toolbar", messageUri, folderUri, null);
				}
	
					try {
						var tree = {};
						var msgDB = {};
						var length = {};
						var wintype = {};
						var msgDBView = {};
						var indicesArray = {};
						this.msgWindow = this.getMsgWindow();
	
						if (document.firstChild.id == "messengerWindow") {
							wintype = window.document.firstChild.getAttribute("windowtype");
							this.msgWindow.SetDOMWindow(window);
	
							folder = this.getMsgFolderFromUri(folderUri);
							msgDB = folder.getMsgDatabase(this.msgWindow);
							msgDB.MarkHdrRead(msgHdr, false, null);
							this.msgWindow.SelectFolder(folderUri);
	
							msgDBView = window.gDBView;
							if (wintype != "mail:messageWindow") tree = window.GetThreadTree();
						} else {
							wintype = window.opener.document.firstChild.getAttribute("windowtype");
							this.msgWindow.SetDOMWindow(window.opener);
	
							folder = this.getMsgFolderFromUri(folderUri);
							msgDB = folder.getMsgDatabase(this.msgWindow);
							msgDB.MarkHdrRead(msgHdr, false, null);
	
							this.msgWindow.SelectFolder(folderUri);
	
							msgDBView = window.opener.gDBView;
							if (wintype != "mail:messageWindow") tree = window.opener.GetThreadTree();
						}
	
					if (wintype != "mail:messageWindow") tree.view.selection.clearSelection();
						msgDBView.selectMsgByKey(msgHdr.messageKey);
						msgDBView.loadMessageByMsgKey(msgHdr.messageKey);
						msgDB.MarkHdrRead(msgHdr, true, null);
						msgDBView.getIndicesForSelection(indicesArray,length);
						if (wintype != "mail:messageWindow") tree.treeBoxObject
												.ensureRowIsVisible(indicesArray.value[0]);
				} catch( e ) { }
			}
		}
	
	
		if ((reminderfox.msgnr.name == "SM2") && (msgHdr == null)) {
			var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
						.getService(Components.interfaces.nsIWindowMediator);
	
			window.openDialog("chrome://messenger/content/", "", "all,dialog=no");
			windowManager.getMostRecentWindow("mail:3pane");
		}
	
	
		// extract the tag keys from the msgHdr
		if (msgHdr != null && labelTag != null ) {
			reminderfox.tagging.msg("Reminderfox", opTag, "#993399" );
	
			// delete all iCal-xxxx tags eg: PUBLISH, REQUEST, REPLY, CANCEL, ICS
				var msgKeyArray = msgHdr.getStringProperty("keywords").split(" ");
	
				if ((opTag == false) && (msgKeyArray.length > 0))  {
					for (var n= 0; n< msgKeyArray.length; n++  ) {
	
						if (msgKeyArray[n].indexOf("ical") == 0) {
						try {
							ToggleMessageTag(msgKeyArray[n], false /*tagOp*/, "", false)  //4th param for PB
						} catch (ex) {}
						}
				}
				}
		}
		window.setCursor("auto");
		return msgHdr;
	},
	
	
		/**
		* Open a new window with the folder and open message
		*
		* @param uriToOpen - folder uri
		* @param msgID - messageID
		*/
		/* ******** ?????????????? is this requied ************* ??????????????
		function rmFx_MsgOpenNewWindowForFolder(uriToOpen, msgID) {
	
		if (uriToOpen)
			window.openDialog("chrome://messenger/content/", "_blank",
					"chrome,all,dialog=no", uriToOpen, msgID);
		}
		??????????????????????? *********************/
	
	  /**
		* Search for messageid in local folders
		*/
	searchMessageLocally : function (messageId) {
		var msgHdr = null;
		var folder = null;
		for(var x = 0; x < this.accountURIs.length && !msgHdr; x++) {
			folder = this.getMsgFolderFromUri(this.accountURIs[x]).rootFolder;
			msgHdr = this.searchInSubFolder(folder, messageId);
		}
		return msgHdr;
	},
	
	
	  /**
		* Searchs in subfolder
		*/
	searchInSubFolder : function (sFolder, messageId) {
	
			if ((reminderfox.msgnr.name == "TB3") || (reminderfox.msgnr.name == "SM2")) {
	
			var subfolder = null;
			var msgHdr = null;
			var msgDB = null;
			var currentFolderURI = "";
	
			var done = false;
	
			if (sFolder.hasSubFolders) {
	
				var subfolders = sFolder.subFolders;
				while (subfolders.hasMoreElements()) {
					var subfolder = subfolders.getNext().QueryInterface(Components.interfaces.nsIMsgFolder);
				//	if (currentFolderURI.substring(1,7) != "news://") {
						msgHdr = this.searchInSubFolder(subfolder, messageId);
				//	}
					if (!msgHdr) {
						try {
							var msgDB = subfolder.msgDatabase;
						} catch (ex) {}
	
						if ( msgDB != null ) msgHdr = msgDB.getMsgHdrForMessageID(messageId);
					}
					if (msgHdr) return msgHdr;
					try {
						subfolders.next();
					} catch(e) {
						done = true;
					}
				} //while
			} //if (sFolder.hasSubFolders)
			return null;
	
		} else {
	
			if (sFolder.hasSubFolders) {  // TB2.
				var subfolders = sFolder.GetSubFolders();
				var subfolder = null;
				var msgHdr = null;
				var msgDB = null;
				var currentFolderURI = "";
				var done = false;
	
				while(!done) {
					currentFolderURI = subfolders.currentItem()
											.QueryInterface(Components.interfaces.nsIRDFResource).Value;
					subfolder = this.getMsgFolderFromUri(currentFolderURI);
	
					if (currentFolderURI.substring(1,7) != "news://") {
								msgHdr = this.searchInSubFolder(subfolder, messageId);
					}
					if (!msgHdr) {
	
						try {
							this.msgWindow = reminderFox_getMsgWindow();
							msgDB = subfolder.getMsgDatabase(this.msgWindow);
						} catch (ex) {
	
						// subfolder.updateFolder(this.msgWindow); // TM: this call was causing a hang in some instances
						// try {
						// // msgDB = subfolder.getMsgDatabase(this.msgWindow);
						// } catch (ex) {
						// }
						}
	
						if ( msgDB != null ) {
							msgHdr = msgDB.getMsgHdrForMessageID(messageId);
						}
					}
					if (msgHdr) return msgHdr;
	
					try {
						subfolders.next();
					} catch(e) {
						done = true;
					}
				}
			}  // TB2.	if (sFolder.hasSubFolders)
			return null;
			// }
		}
	},
	
	
		/**
		* Searchs all availible newsserver
		*/
	addNewsServers : function () {
		if (this.prefRead == false) {
			var accounts = this.pmpReadPref("mail.accountmanager.accounts",this.pmpS);
			if (accounts) {
					var accountsArray = accounts.split(",");
	
					for (var x = 0; x < accountsArray.length; x++) {
						this.addNewsServerMenuItem(accountsArray[x]);
					}
					this.accountURIs.sort(this.sortAccountUris);
			}
	
			this.prefRead = true;
		}
	},
	
	
		/**
		* Sortfunction for this.accountURIs Array Local Folder to the rear
		*
		* @param a and b
		* @return  1:	;	-1:
		*/
	sortAccountUris : function (a, b) {
	
		if (a.search(/Local%20Folders/) != -1) {
			return 1;
		} else if (b.search(/Local%20Folders/) != -1) {
			return -1;
		} else if (a < b) {
			return -1;
		} else if (a > b) {
			return 1;
		} else {
			return 0;
		}
	},
	
	
		/**
		* Adds newsserver to the context menu
		*
		*/
	addNewsServerMenuItem : function (account) {
		var server	= this.pmpReadPref("mail.account." + account + ".server",this.pmpS);
		var servertyp = this.pmpReadPref("mail.server."  + server +  ".type",this.pmpS);
		var hostname  = this.pmpReadPref("mail.server."  + server +  ".hostname",this.pmpS);
		var username  = this.pmpReadPref("mail.server."  + server +  ".userName",this.pmpS);
	
		var accountURI = "";
	
		if (servertyp == "nntp") {
			var servername = this.pmpReadPref("mail.server." + server + ".name",this.pmpS);
			var serverport = this.pmpReadPref("mail.server." + server + ".port", this.pmpN);
			// var newsservermenuitem;
	
			if (servername == null) servername = hostname;
			if (serverport == null) serverport = 119;
	
			accountURI = "news://" + escape(hostname);
		} else if (servertyp == "imap") {
			accountURI = "imap://" + escape(username) + "@" + escape(hostname);
		} else {
			accountURI = "mailbox://" + escape(username) + "@" + escape(hostname);
		}
	
		if (hostname != null) this.accountURIs.push(accountURI);
	},
	
	
	
	/**
		* Reads the value of pmpName out of the mozilla preferences
		*
		* @param	pmpName
		* @param	pmpType	Bool,Integer or Char
		*
		* @return	pmpValue
		*/
	pmpReadPref : function (pmpName, pmpType) {
		var nsIPrefBranch = Components.interfaces.nsIPrefBranch;
		var pref = Components.classes["@mozilla.org/preferences-service;1"]
									.getService(nsIPrefBranch);
		var pmpValue = null;
	
		if (pref.prefHasUserValue(pmpName)) {
			switch (pmpType) {
					case this.pmpB:
						pmpValue = pref.getBoolPref(pmpName);
						break;
					case this.pmpN:
						pmpValue = pref.getIntPref(pmpName);
						break;
					case this.pmpS:
						pmpValue = pref.getCharPref(pmpName);
						break;
					default:
						break;
			}
		}
	
		return pmpValue;
	},
	
	
		/**
			* Get msgfolder from Uri
			*
			* @param	uri
			* @return	null or msgfolder
			*/
	getMsgFolderFromUri : function (uri) {
		var msgfolder = null;
	
		try {
			var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
										.getService(Components.interfaces.nsIRDFService);
			var resource = RDF.GetResource(uri);
	
			if (resource instanceof Components.interfaces.nsIMsgFolder &&
				(resource.parent || resource.isServer))
				msgfolder = resource;
	
		} catch (ex) {}
	
		return msgfolder;
	}

}; // reminderfox.messageId.

////////////////// end of 'MessageID' //////////////////////////////////////////


///////////////// .msngr. /////Utilities for Messages  ////////////////////////

if(!reminderfox) var reminderfox={};
if(!reminderfox.msgnr) reminderfox.msgnr={};


	reminderfox.msgnr.Compose = function (subject, fromAddress,  toAddresses,
				priority, body, footer, refID, iCalToEmailFile, methodTyp) {
	// =========================================================================
		if (reminderfox.util.messenger()) {
			var fromId = reminderfox.msgnr.getIdentity (fromAddress);

			if (iCalToEmailFile != null) {
				var msgAttachment					= Components.classes["@mozilla.org/messengercompose/attachment;1"]
															.createInstance(Components.interfaces.nsIMsgAttachment);
				msgAttachment.temporary = true;
				msgAttachment.name = iCalToEmailFile.leafName;
				msgAttachment.contentType = "text/calendar;"
				msgAttachment.contentTypeParam = "method=" + methodTyp + "; charset=UTF-8";
	//gWTEST Darwin			msgAttachment.url = "file://" + iCalToEmailFile.persistentDescriptor;
				msgAttachment.url = "file://" + iCalToEmailFile.path;
			}

			// mail header
			var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
					.createInstance(Components.interfaces.nsIMsgCompFields);
			composeFields.useMultipartAlternative = true;

			composeFields.characterSet = "UTF-8";
			composeFields.from  = fromId.email;
			composeFields.replyTo = fromId.email;

			toAddresses = (toAddresses == "null") ? "" : toAddresses;
			composeFields.to = toAddresses;				// XXX  +++2todo ???????????

				function exHtml(xString){
					return xString.replace(new RegExp(/</g),"&lt;").replace(new RegExp(/>/g),"&gt;")
				}

			composeFields.subject = subject;
			composeFields.body = exHtml(body + footer);
			composeFields.priority = priority;

			if (iCalToEmailFile != null) {
				composeFields.addAttachment(msgAttachment);
			}
			// message compose paramaters
			var msgComposeParams					= Components.classes["@mozilla.org/messengercompose/composeparams;1"]
															.createInstance(Components.interfaces.nsIMsgComposeParams);
			msgComposeParams.composeFields 	= composeFields;
			msgComposeParams.identity 			= fromId;
			msgComposeParams.format 			= Components.interfaces.nsIMsgCompFormat.Default;
			msgComposeParams.type 				= Components.interfaces.nsIMsgCompType.New;

			// open a composer window
			var messengerCompose = Components.classes["@mozilla.org/messengercompose;1"]
						.getService().QueryInterface(Components.interfaces.nsIMsgComposeService);
			messengerCompose.OpenComposeWindowWithParams(null, msgComposeParams);

			try { // with Remote send this will fail, also we don't have dialog open to place the status info
				reminderfox.core.statusSet ("Send message by " + fromId.identityName + " pending." , "");		//gW RmFxStatusbar
			} catch (ex) {}
		} else {
			/** -- NO 'messenger' .. (like FX) ----------------------------------- **/
			/*	calling TB -reminderFox COMPOSE:{info about what to compose}	*/

			//messageString definition
			var msgString = "Subject:"  + subject
						+ ";\n;From:"		+ fromAddress
						+ ";\n;To:"		+ toAddresses
						+ ";\n;Body:"		+ body
						+ ";\n;Footer:"	+ footer
						+ ";\n;priority:"  + priority
						+ ";\n;refID:"	+ refID;


			if (iCalToEmailFile != null) {
					msgString += ";\n;mailFile:"  + iCalToEmailFile.path;
			}

			msgString = escape(msgString);

			var mailApp = reminderfox.util.messengerApp();
			if ((mailApp == null) || (mailApp == ""))  {
				reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.messenger.notfound"));
				return;
			}

			var args = new Array();
			args [0] = "-reminderFox";
			args [1] = "COMPOSE:" + subject;
			args [2] = "-msgString";
			args [3] = msgString;		// compose items to be passed

			var go4Process = Components.classes["@mozilla.org/process/util;1"]
					.createInstance(Components.interfaces.nsIProcess);

			try {
				go4Process.init(mailApp);
			} catch (ex) {}
			go4Process.run(false, args, args.length);

			return;		// FX schedules TB with COMPOSE:subject -msgString msgString
		}
	}



	/**
	* Send File
	*
	* @see
	*  http://mxr.mozilla.org/comm-central/source/mailnews/compose/public/nsIMsgSend.idl
	*  http://mxr.mozilla.org/comm-central/source/mailnews/compose/public/nsIMsgCompFields.idl
	*
	* @param subject		the 'subject' the mail comes with
	* @param fromAddress	the 'FROM' address sending the msg
	* @param toAddresses	the 'TO' addresses to receive the msg (csv)
	* @param body			any message 'body' to be send
	* @param tmpFile		file object containing the message
	*/
	reminderfox.msgnr.FileSend = function ( subject, fromAddress, toAddresses,
												priority, mailFile, refID) {
	// =========================================================================
		if ( reminderfox.util.messenger()) {		//try	// 'in 'messenger' ??
			// need different code for TB2 and TB3/SM2 !!!
			if("@mozilla.org/filespec;1" in Components.classes) {
				// this TB2 code
				var mailFileURL = reminderfox.util.getIOService().newFileURI(mailFile).spec;
				mailFile = Components.classes["@mozilla.org/filespec;1"]
					.createInstance(Components.interfaces.nsIFileSpec);
				mailFile.URLString = mailFileURL;
			}

			var fromId = reminderfox.msgnr.getIdentity (fromAddress);

			var composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
					.createInstance(Components.interfaces.nsIMsgCompFields);
			composeFields.characterSet = "UTF-8";
			composeFields.to				= toAddresses;
			composeFields.from			= fromId.identityName;
			composeFields.replyTo		= fromId.identityName;

			composeFields.priority		= reminderfox.msgnr.setPriorityString (priority);


			var messengerSend = Components.classes["@mozilla.org/messengercompose/send;1"]
							.createInstance(Components.interfaces.nsIMsgSend);
			messengerSend.sendMessageFile(
						fromId,				/* nsIMsgIdentity */
						fromId.key,			/* nsIMsgCompFields */
						composeFields,		/* nsIMsgCompFields */
						mailFile,			/* nsFileSpec */
						reminderfox.mail.deleteSendFileOnCompletion,
						false,				/* digest_p */
												/* nsMsgDeliverMode */
						reminderfox.util.getIOService().offline
							?	Components.interfaces.nsIMsgSend.nsMsgQueueForLater	/* = 1 */
							:	Components.interfaces.nsIMsgSend.nsMsgDeliverNow,	/* = 0 */
						null,		/* nsIMsgDBHdr msgToReplace */
						null,		/* nsIMsgSendListener aListener */
						null,		/* nsIMsgStatusFeedback aStatusFeedback */
						"");		/* password */

		} else { // if the above fails .. in 'NON messenger'

			reminderfox.msgnr.sendwUID (refID, mailFile.path);
		}
	}

	/**
	* File Creation for message
	*
	*  FX:  encodes the whole 'content' string with .encodeUTF8
	*  TB:  NO encodes the whole 'content'
	*/
	reminderfox.msgnr.FileCreate = function (subject, fromAddress, toAddresses, priority,
										body, footer,
										refID, iCalString, methodTyp) {
	//=====================================================================
		var thisdate = new Date();

		// add app info  .. will be added to the 'footer'
		var osInfo = reminderfox.core.opSystemInfo();
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		var appDetails = "\n  " + appInfo.name + " " + appInfo.version
							+ " (" + appInfo.platformBuildID + ") -- " + osInfo;

		var content = "MIME-version: 1.0\r\n";
		content += "To: " + toAddresses + "\r\n";

		if ( reminderfox.util.messenger()) {
			var contentS = "Subject: " + reminderfox.msgnr.encodeMimeHeader(subject) + "\r\n";
			contentS += "From: " + reminderfox.msgnr.getIdentity (fromAddress).identityName + "\r\n";
		} else {
			var contentS = "Subject: " + subject + "\r\n";
			contentS += "From: " + fromAddress + "\r\n";
		}
		content += contentS;

		content += "Date :" + reminderfox.date.mailDateTime(thisdate, "mailDate") + "\r\n";
		content += reminderfox.msgnr.setPriorityString(priority) + "\r\n";
		content += "Content-class: urn:content-classes:reminderfox\r\n";

		var newDate = new Date();
		var msgId = reminderfox.core.generateUniqueReminderId( newDate );

		if (refID != "") {
			content
			+= "Reference-ID: <" + refID + reminderfox.mail.ReferenceID + ">\r\n"
			+ "In-Reply-To: <" + refID + reminderfox.mail.ReferenceID + ">\r\n";
			+ "Message-Id: <" + msgId + reminderfox.mail.ReferenceID + ">\r\n";
		//gw_messageID/In-Reply-To w send/reply invitation
		}

		// if 'iCalString' and 'methodTyp'  send with iCal attachment
		if (!!iCalString && !!methodTyp) {
			content
			+= ("Content-type: multipart/mixed; boundary=\"anhang_1234567890_0987654321\"\r\n"
			+		"\r\n\r\n"
			+		"--anhang_1234567890_0987654321\r\n"
			+		"Content-type: multipart/alternative;\r\n"
			+		" boundary=\"anhang_0987654321_1234567890\"\r\n"
			+		"\r\n\r\n"
			+		"--anhang_0987654321_1234567890\r\n"
			+		"Content-type: text/plain; charset=UTF-8\r\n"
			+		"Content-transfer-encoding: 8BIT\r\n"
			+		"\r\n"

			+		body

			+ "\n-- "  /* footer delimiter line !!! do not delete !
							this notation will cut the following part from plain-text-reply !*/
			+  "\n" + footer + appDetails
			+  "\n  ________________________________________________"
			+  "\n  " + reminderfox.core.consts.REMINDER_FOX_PAGE_URL + "\n"

			+		"\r\n\r\n\r\n"
			+		"--anhang_0987654321_1234567890\r\n"
			+		"Content-type: text/calendar; method=" + methodTyp + "; charset=UTF-8\r\n"
			+		"Content-transfer-encoding: 8BIT\r\n"
			+		"\r\n"

			+		iCalString
			+		"\r\n\r\n"

			+		"--anhang_0987654321_1234567890--\r\n\r\n"

			+		"--anhang_1234567890_0987654321\r\n"
			+		"Content-type: application/ics; name=invite.ics\r\n"
			+		"Content-transfer-encoding: 8BIT\r\n"
			+		"Content-disposition: attachment; filename=invite.ics\r\n"
			+		"\r\n"	/* need an extra line to separate header !! */

			+		iCalString
			+		"\r\n\r\n"

			+		"--anhang_1234567890_0987654321--\r\n");

		} else {	// send message with inline text

			content
			+= "Content-type: text/plain; charset=UTF-8\r\n"
			+  "Content-transfer-encoding: 8bit\r\n\r\n"
			+  body

			+  "\n-- "  /* footer delimiter line !!! do not delete !
								this notation will cut the following part from plain-text-reply !*/
			+  "\n" + footer + appDetails
			+  "\n  ________________________________________________"
			+  "\n  http://www.reminderfox.org/\n";
		}

		if ( !reminderfox.util.messenger()) {
			content = reminderfox.util.encodeUTF8(content);
		}

		// ------ write TMP file ---------------
		return  reminderfox.util.makeMsgFile8 (content, reminderfox.util.buildUIDFile(refID));
	}



	reminderfox.msgnr.setPriorityString = function (priority) {
	// =========================================================================
		var cPriority = "";
		switch (priority) {
		case "1": cPriority		= "X-Priority: 1 (Highest)"; break;
		case "2": cPriority		= "X-Priority: 2 (High)";	break;
		case "3": cPriority		= "X-Priority: 3 (Normal)";  break;
		case "4": cPriority		= "X-Priority: 4 (Low)";	break;
		case "5": cPriority		= "X-Priority: 5 (Lowest)";  break;
		default:  cPriority		= "X-Priority: 3 (Normal)";  break;
		}
		return cPriority;
	}


/////////////////// 'SendFILE' for "NON" messenger	///////////////////////////
	/**
	*	use a specific 'commandLine' Handler ... this is the NON 'messenger' part
	*/
	reminderfox.msgnr.sendwUID = function (reminderID, msgString) {
	// =========================================================================
		var mailApp = reminderfox.util.messengerApp();
		if ((mailApp == null) || (mailApp == ""))  {
			reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.messenger.notfound"));
			return;
		}

		var osInfo = reminderfox.core.opSystemInfo();

		var args = new Array();
		args [0] = "-reminderFox";
		args [1] = "UID:"+ (reminderID);
		args [2] = "-msgString";

								//gWTEST platformIsMac; STEEL ????????????
		if(osInfo.indexOf("Darwin") != -1) {
			args [3] = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("TmpD", Components.interfaces.nsIFile);
		} else {
			args [3] = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("Progs", Components.interfaces.nsIFile).path.substring(3);
		}

		var cDate = new Date();
		var msgLog = " ** Send with **	UID:" + reminderID + " at: " + cDate;
		reminderfox.core.statusSet(msgLog);

		var go4Process = Components.classes["@mozilla.org/process/util;1"]
					.createInstance(Components.interfaces.nsIProcess);

		try {
			go4Process.init(mailApp);
			} catch (ex) {}
		go4Process.run(false, args, args.length);

		return;		// scheduled TB with UID:reminderID -msgString mailFile.path
	}

	/**
	*  called from 'commandLine' Handler ... this is the 'messenger' part
	*/
	reminderfox.msgnr.sendwUIDgo = function () {
	// ========================================================================
		if (!(reminderfox.mail.cmdID.indexOf('UID:') > -1)) { // check transfered code and validity
			return;	// not valid!! Terminate
		}
		window.close();

		var icsFile = reminderfox.util.buildUIDFile(reminderfox.mail.cmdID.substring(4))

reminderfox.util.dump2Console ( 'Darwin', "sendwUIDgo icsFile >>" + icsFile + "<<");			//gWTEST Darwin	sendwUIDgo


		var icsData = reminderfox.util.readInFileContents(icsFile)
						.replace(/(\r\n)/g,"\n");

		if (icsData.indexOf (reminderfox.mail.cmdID+"\n") == -1) {
			var msgError = "*** Transfered ICS data has error: -1 ***"
					+ "\n	data >>" +  reminderfox.mail.cmdID + "<<";
			reminderfox.util.dump2Console ('error', msgError);
			return;	// not valid!! Terminate
		}


	/* ----- check if file valid -----	+++2Todo 	+++2Todo 	+++2Todo 	+++2Todo
		var osInfo = reminderfox.core.opSystemInfo();		<<-- with Darwin fails !!
		if(osInfo.indexOf("Darwin") == -1) {

			if (reminderfox.mail.cmdString !=  Components.classes["@mozilla.org/file/directory_service;1"]
						.getService(Components.interfaces.nsIProperties)
						.get("Progs", Components.interfaces.nsIFile).path.substring(3)) {
				var msgError = "*** Transfered ICS data has error: -2 ***";

				reminderfox.util.dump2Console ('error', msgError);
				return;	// not valid!! Terminate
			}
		} else {
			if (reminderfox.mail.cmdString !=  Components.classes["@mozilla.org/file/directory_service;1"]
						.getService(Components.interfaces.nsIProperties)
						.get("TmpD", Components.interfaces.nsIFile).path.substring(3)) {
				var msgError = "*** Transfered ICS data has error: -2 (Darwin) ***";

				reminderfox.util.dump2Console ('error', msgError);
				return;	// not valid!! Terminate
			}
		}
	-------------- */

		var msgString = reminderfox.mail.cmdString.split(";\n;");

		// retrieve msg infos from 'ics file'
		var msgLines = icsData.split("\n");

		var toAddresses	= msgLines[1].substring(4);
		var subject			= msgLines[2].substring(9);
		var fromAddress	= msgLines[3].substring(6);
		var priority		= msgLines[5].substring(12,13);

		reminderfox.util.makeMsgFile (msgLines.join("\n"), icsFile);

		var mailFile = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		mailFile.initWithPath(icsFile);

		reminderfox.msgnr.FileSend(
					subject,
					fromAddress,
					toAddresses,
					priority,
					mailFile);
	}

//////////////////// 'COMPOSE' for NON 'messenger'	///////////////////////////

	/**
	*	use a specific 'commandLine' Handler ... this is the NON 'messenger' part
	*
	**/
	reminderfox.msgnr.composeMSG = function (reminderID, msgString) {
	// =========================================================================
		var mailApp = reminderfox.util.messengerApp();
		if ((mailApp == null) || (mailApp == ""))  {
			reminderfox.util.PromptAlert(reminderfox.core.getBundle().getString("rf.messenger.notfound"));
		return;
		}

		var args = new Array();
		args [0] = "-reminderFox";
		args [1] = "COMPOSE:"+ (reminderID);
		args [2] = "-msgString";
		args [3] = msgString;

		var go4Process = Components.classes["@mozilla.org/process/util;1"]
				.createInstance(Components.interfaces.nsIProcess);

		try {
			go4Process.init(mailApp);
		} catch (ex) {}
		go4Process.run(false, args, args.length);
		return;		// FX schedules TB with COMPOSE:reminderID -msgString msgString
	}

/**
  *  called from 'commandLine' Handler ... this is the 'messenger' part
  */
	reminderfox.msgnr.composeMSGgo = function () {
	// =========================================================================
		if (!(reminderfox.mail.cmdID.indexOf('COMPOSE:') > -1)) { // check transfered code and validity
			return;	// not valid!! Terminate
		}
		window.close();

		// retrieve msg infos from passed window parameters
		var msgString = unescape(reminderfox.mail.cmdString).split(";\n;");

		var subject		= msgString[0].substring(8);
		var fromAddress	= msgString[1].substring(5);
		var toAddresses	= msgString[2].substring(3);
		var body			= msgString[3].substring(5);
		var footer		= msgString[4].substring(7);
		var priority		= msgString[5].substring(9);
		var refID			= msgString[6].substring(6);

reminderfox.util.dump2Console('Darwin', "composeMSGgo icsFile string >>" + msgString[7] + "<<");			//gWTEST Darwin

		if (msgString[7] != null) {
			var icsFile		= msgString[7].substring(9);
			var mailFile = Components.classes["@mozilla.org/file/local;1"]
						.createInstance(Components.interfaces.nsILocalFile);
			mailFile.initWithPath(icsFile);
		} else {
			mailFile = null;
		}

	// var toAddresses	= "";
	var methodTyp	= "PUBLISH";

	reminderfox.msgnr.Compose (subject, fromAddress,  toAddresses,
		priority, body, footer, refID, mailFile, methodTyp);
	}

//////////////////// utilities 'messenger' /////////////////////////////////////


	reminderfox.msgnr.getAccountMngr = function  () {
	// =========================================================================
		return Components.classes["@mozilla.org/messenger/account-manager;1"]
				.getService().QueryInterface(Components.interfaces.nsIMsgAccountManager);
	}

	reminderfox.msgnr.encodeMimeHeader = function (header) {
	// =========================================================================
	// http://www.xulplanet.com/references/xpcomref/ifaces/nsIMimeConverter.html
		var mimeConverter = Components.classes["@mozilla.org/messenger/mimeconverter;1"]
						.createInstance(Components.interfaces.nsIMimeConverter);
		return mimeConverter.encodeMimePartIIStr(reminderfox.util.encodeUTF8(header), false,
						"UTF-8", header.indexOf(":") + 2, 72);
	}

	/**
	*	'messenger'		use mail.accountmanager.accounts and identities
	*	NON 'messenger'	prefs = extensions.reminderFox.mail.sender
	*/
	reminderfox.msgnr.myMailIDs = function () {
	// =========================================================================
	if (reminderfox.util.messenger()) { // OK: if we are in 'mail' system (TB, SM)

		// this is tree pass process to eliminate identities for 'nntp'
		//  sounds complicate ... but didn't found a straight forward process
		var as = Components.classes["@mozilla.org/messenger/account-manager;1"]
			.getService(Components.interfaces.nsIMsgAccountManager).allServers;
		var servers="";
		for (var i = 0; i < as.Count(); ++i) {
			var nextTyp  = as.GetElementAt(i)
				.QueryInterface(Components.interfaces.nsIMsgIncomingServer).type;
			if (nextTyp != "nntp") {
				var nextKey  = as.GetElementAt(i)
					.QueryInterface(Components.interfaces.nsIMsgIncomingServer).key;
				servers += nextKey +",";
			}
		}

		var _prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefBranch);
		var accounts = _prefs.getCharPref("mail.accountmanager.accounts");

		var idstr="";
		if (accounts) {
			var accountsArray = accounts.split(",");
			for (var x = 0; x < accountsArray.length; x++) {
				var temp1 = _prefs.getCharPref("mail.account." + accountsArray[x] + ".server");
				if (servers.indexOf(temp1)> -1) {
				try { idstr += _prefs.getCharPref("mail.account." + accountsArray[x]
						+ ".identities") +",";}
					catch (ex) {}
				}
			}
		}

		var ids = Components.classes["@mozilla.org/messenger/account-manager;1"]
				.getService(Components.interfaces.nsIMsgAccountManager).allIdentities;
		var mailIds = "";
		for (var i = 0; i < ids.Count(); ++i) {
			var nextId  = ids.GetElementAt(i).
								QueryInterface (Components.interfaces.nsIMsgIdentity);
				if (idstr.indexOf(nextId.key)> -1) {
					try { mailIds += nextId.identityName + ",";}
						catch (ex) {}
				}
		}
		// delete last comma
		mailIds = mailIds.substring(0,mailIds.length-1);

		} else { // 'NON messenger' .. eg.FX etc ...
			try {
				var mailIds = reminderfox.core.consts.reminderFox_prefsBranch.getCharPref(reminderfox.core.consts.MAIL_SENDER);
			} catch (ex) {}
		}
		return mailIds;
	}

	/**
	* checks all non-nntp servers for valid 'fromAddress'
	* returns the 'identity'
	* If not matching
	* -- not valid mailName --> take first valid identity for that server
	* -- at all, take 'defaultAccount.defaultIdentity'
	*
	* in NON 'messenger' just return the 'fromAddress'
	*/
	reminderfox.msgnr.getIdentity = function (fromAddress) {
	// =========================================================================
		var ids = Components.classes["@mozilla.org/messenger/account-manager;1"].
								getService(Components.interfaces.nsIMsgAccountManager).allIdentities;
		if ((fromAddress != null ) &&  (fromAddress != "" )) {
			var returnId = null;
			var xMailAdr ="x";
			var xId = -1;
			for (var i = 0; i < ids.Count(); ++i) {

				var nextId  = ids.GetElementAt(i).
									QueryInterface (Components.interfaces.nsIMsgIdentity);
				if ((fromAddress.indexOf(nextId.email) > -1) && (xMailAdr != nextId.email)){
					xMailAdr =nextId.email;
					xId = i;
				}
				if (nextId.identityName == fromAddress) {return nextId;}
			}
		}

		// not found at all, return default
		return  reminderfox.msgnr.getAccountMngr().defaultAccount.defaultIdentity;
	}


	/**
	* Checks for the messenger version (TB2, TB3, SM, PB)
	* and sets the global parameter 'reminderfox.msgnr.name'
	* 
	* If in Firefox returns empty string
	*
	* @return  [string]  reminderfox.msgnr.name
	*/
	reminderfox.msgnr.whichMessenger = function () {
	// =========================================================================
		if (reminderfox.msgnr.name == "") {

			var idName = "";
			
			// https://developer.mozilla.org/en/Using_nsIXULAppInfo
			var id;
			if("@mozilla.org/xre/app-info;1" in Components.classes) {
			// running under Mozilla 1.8 or later
				id = Components.classes["@mozilla.org/xre/app-info;1"]
					.getService(Components.interfaces.nsIXULAppInfo).ID;
			} else {
				try {
					id = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefBranch)
						.getCharPref("app.id");
				} catch(e) {}
			}
	
			var _prefs = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefBranch);
			switch (id) {
				case (reminderfox.util.POSTBOX_ID) :	idName = "PB"; break;
				case (reminderfox.util.SEAMONKEY_ID) : {
					var tbVersion = _prefs.getCharPref("general.useragent.extra.seamonkey");
					if (tbVersion.search("/1.") > -1) idName = "SM1";
					if (tbVersion.search("/2.") > -1) idName = "SM2";
					break;
				}
				case (reminderfox.util.THUNDERBIRD_ID) :  {
					var tbVersion = _prefs.getCharPref("general.useragent.extra.thunderbird");
	
					if (tbVersion.search("/1.") > -1) idName = "TB1";
					if (tbVersion.search("/2.") > -1) idName = "TB2";
					if (tbVersion.search("/3.") > -1) idName = "TB3";
					break;
				}
			}
	
			reminderfox.msgnr.ab3 = (idName == "TB3") || (idName == "SM2"); //  || (msgnrType == "PB"));
			reminderfox.msgnr.name = idName;
	
var msg = "reminderfox.msgnr.name: " + reminderfox.msgnr.name 
		+ "  reminderfox.msgnr.ab3: " + reminderfox.msgnr.ab3;
reminderfox.util.dump2Console ("gRmFx", msg, Components.stack.caller);
		}
		return reminderfox.msgnr.name;
	}