
if(!reminderfox)			var	reminderfox = {};

if(!reminderfox.userIO)		reminderfox.userIO = {};

	/**
	* DragNDrop    <br>
	* -----------------------------------------------     <br>
	* 	D&D was not working with FX due to old functions.
	* 	Changed to Gecko 1.9.2 concept    <br>
	* 	Firefox / Thunderbird:    <br>
	* 	======================    <br>
	* 	- Subscription:  needs some rework, inconsist UI    <br>
	* 	- Link:    <br>
	* 		-- adds reminder with  subject/notes/url    <br>
	* 	- Text    <br>
	* 	  -- adds reminder with first 40chars to summary    <br>
	* 		  all text goes to notes    <br>
	* 	  -- a first 'http://' link will be parsed to reminder.url    <br>    <br>
	* 
	* 	- OS file    <br>
	* 	  -- adds reminder if file contains ICS data    <br>
	* 
	* 	Thunderbird Extras (other should work, tests required):    <br>
	* 	====================    <br>
	* 	- Link:    <br>
	* 	  -- add reminder with subject/notes/url    <br>
	* 	  -- message header data used for reminder    <br>
	* 	  -- works with data from web page, msg header skipped     <br/>
	* 	- Message:    <br>
	* 	  -- works with d&d from 3pane works,    <br>
	* 	  -- reads ICS from body and attachment(s)    <br>
	* 	- Message Attachment:    <br>
	* 	  -- works with one or multiple selected attachments     <br>
	* 	  -- how are PDF,JPG etc handled?    <br>
	 * @since  2009-01-04  	new		FX3.1    <br>
	 * @since  2011-04-11  rework for new moz drag&drop to work with FX4 etc    <br>
	 * 
	 * @param {Object} event
	 */
	reminderfox.userIO.go = function(event){

		reminderfox.util.JS.dispatch('iCalMail');
		reminderfox.util.JS.dispatch('mail');
		//	reminderfox.util.JS.dispatch('icalendar');				//jquery / icalendar

		var info = "";
		var eventData = "";

		var details = reminderfox.util.selectionDetails();

		info = "OSfile  'Import iCal data' from external data source /applications";
		if (event.dataTransfer.types.contains("text/x-moz-url") &&
		event.dataTransfer.getData("text/x-moz-url").indexOf('file://') == 0) {
reminderfox.util.dump2Console('refactor', "OS file");

			eventData = event.dataTransfer.getData("text/x-moz-url")

			var filePath = reminderfox.util.urlToPath(eventData); //gW_DDlinux  2010-08-27
			if (filePath != null) {
				var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				localFile.initWithPath(filePath);
				var inputStream = reminderfox.core.readInFileContents(localFile);

				if ((inputStream.indexOf("BEGIN:VCALENDAR") != -1) &&
				((inputStream.indexOf("VEVENT") != -1) || (inputStream.indexOf("VTODO") != -1))) {
					var mInvitation = reminderfox.core.getBundle().getString("rf.schedule.import.dataof") +
					" File: [" + filePath + "]";
					reminderfox.iCal.getiCalFromString(inputStream, mInvitation, info);
				}
			}
			return;
		}


		info = " 'Add Reminder' for Message (IMAP, POP/LOCAL, NEWS)";
		if (event.dataTransfer.types.contains("text/x-moz-message")) {
reminderfox.util.dump2Console('refactor', "Message");
		
			reminderfox.iCal.addReminder4Message(event.dataTransfer.getData("text/x-moz-message"), details, info);
			return;
		}

		info = " 'Add Reminder' for Message Attachment  (IMAP, POP/LOCAL, NEWS)";
		if (event.dataTransfer.types.contains("application/x-moz-file-promise")) {
reminderfox.util.dump2Console('refactor', "Message Attachment");

			reminderfox.iCal.addReminder4Message(event.dataTransfer.getData("text/x-moz-url"), details, info);
			return;
		}

		info = "FX/TB LINK or 'Subscribe' from a URL containing an .ics file containing iCal data";
		if (event.dataTransfer.types.contains("text/uri-list")) {
reminderfox.util.dump2Console('refactor', "LINK or Subscription");

			info = " 'Add Reminder' for URL link  -- see for Subscription";
			var linkData = event.dataTransfer.getData("text/x-moz-url-data");

			// check  for 'subscription'
			if (((linkData.indexOf('http') == 0) || (linkData.indexOf('webcal:') == 0)) &&
			(linkData.indexOf(".ics") == linkData.length - 4)) {

				// Subscription
				reminderfox.userIO.subscribeOrAddReminder(event.dataTransfer.getData("text/x-moz-url"), info);
				return;
			}

			info = "FX/TB a 'normal' Link"

			if (event.dataTransfer.types.contains("application/x-moz-file")) { 
				// this is from browser/FX
				details = reminderfox.util.selectionDetails(false);
				details.infos.url = event.dataTransfer.getData("text/x-moz-url-data");
				details.infos.subject = event.dataTransfer.getData("text/x-moz-url-desc");
				details.text = "Browser link";
				
			} else {
				// this is from thunderbird/Msgnr
				details = reminderfox.util.selectionDetails();
				details.infos.url = event.dataTransfer.getData("text/x-moz-url-data");
				details.text = event.dataTransfer.getData("text/x-moz-url-desc");
			}
			reminderfox.userIO.defaultMode(details, info);
			return;
		}

		// noting matched, so process as 'text' but check for 
		//   -- containing iCal data
		//   -- the first 'http://"' to store it to reminder.url

		// reset 'details' if d&d is from FX
		if (event.dataTransfer.types.contains("application/x-moz-file")) {
			details = {};
		}

		// check if the text has valid iCal Data 
		var text = event.dataTransfer.getData("text/plain")
		info = "'Text' - check for iCal data content"
		var description = reminderfox.core.getBundle().getString("rf.add.mail.message.subject") 
			+ ": " + details.summary;
		if (reminderfox.iCal.getiCalFromString(text, description, info)) return;


		info = "'Text' - check for http:// to set 'reminder.url'"
reminderfox.util.dump2Console('refactor', "TEXT (see for first http:// ")

		var textUrl = "";
		eventData = event.dataTransfer.getData("text/html")
		var a = eventData.indexOf('href="http://');
		if (a != -1) { // hee, we have an URL, lets grap it (the first) and add it to the reminder

			var e = eventData.substring(a + 6).indexOf('"');
			if (e == -1) {
				textUrl = eventData.substring(a);
			}
			else {
				textUrl = eventData.substring(a + 6, a + eventData.substring(a + 6).indexOf('"') + 6);
			}
			textUrl = reminderfox.util.unEscapeHtml(textUrl)
		}


		eventData = event.dataTransfer.getData("text/plain");
		var details = reminderfox.util.selectionDetails(null, eventData);

		// write a text link to the reminder.url, in that case
		// if page url is available, write that url as start of reminder.notes
		if (textUrl != "") {
			details.url = textUrl;
		} 
		reminderfox.userIO.defaultMode(details, info);
	
	};


/**
 * userIO.defaultMode
 * 
 * @param {Object} details
 * @param {Object} info
 */
reminderfox.userIO.defaultMode = function (details, info) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
reminderfox.util.dump2Console ('refactor', "rm4plainText: " + details.summary 
			+ "\n info: " + info, Components.stack.caller);	//gWrefactor

		reminderfox.util.JS.dispatch('tag');


	var newDate = new Date();
	newDate.setDate( newDate.getDate() );  // default to using today's date for reminder
	var reminderId =reminderfox.core.generateUniqueReminderId( newDate );
	var newReminderToBeAdded = new reminderfox.core.ReminderFoxEvent(reminderId, newDate, details.infos.subject);

	if ((details.text != "" ) && (details.text != "" )) {
		newReminderToBeAdded.notes = details.text;
	}
	if ((details.messageId != "" ) && (details.messageId != null )) {
		newReminderToBeAdded.messageID = details.messageId;
	}
	if ((details.url != "" ) && (details.url != null)) {
		newReminderToBeAdded.url = details.url;
	}
	if (details.infos.url != null ) {
		newReminderToBeAdded.url = details.infos.url;
	}

	var rv = reminderfox.core.addReminderHeadlessly( newReminderToBeAdded );
	if (rv && details.messageId != "") {reminderfox.tagging.msg("Reminderfox", true, "#993399")};
	return rv;
};


/**
 *  Add email reminder for current selected message
 */
reminderfox.userIO.addReminder4Email = function (info, msg) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	try {
		document.getElementById('threadPaneContext').hidePopup();
	} catch (e) {}
	try {
		document.getElementById('messagePaneContext').hidePopup();
	} catch (e) {}

// single Link 
//document.popupNode.href
//document.popupNode.textContent

// Text wih link
//document.popupNode.textContent.replace(/\n/g, ' ').indexOf(selectedText)

	var msgDetails = reminderfox.util.selectionDetails();

	reminderfox.userIO.defaultMode (msgDetails, " messengerAddEmailReminder " /*info*/)
	return;
}

/**
 *    Add Reminder w Context/Toolbar Menu
 */
reminderfox.userIO.addReminder4WebPage = function(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var details = reminderfox.util.selectionDetails();

//		details.infos.url = event.dataTransfer.getData("text/x-moz-url").split("\n")[0];
//		details.text = event.dataTransfer.getData("text/x-moz-url").split("\n")[1];

	reminderfox.userIO.defaultMode (details, "addReminderForWebPage" /*info*/);
}


//          *** Subscription / Add Reminder **** 

reminderfox.userIO.icsOrwebcalURL = null;
reminderfox.userIO.icsOrwebcalURLname = null;

/**
 *  Support D&D a URL download link (ICS/webcal) to 'Subscribe' or 'add reminders' <br>
 *  ex:  http://dl.erweiterungen.de/kalenderdateien/Feiertage_2006-2010_DE.ics  <br> 
 *  ex:  webcal://sports.yahoo.com/nfl/teams/pit/ical.ics  <br>
 *    <br>
 *  @since	2008-10-30    <br>
 *  @since	2010-11-06  support subscription and import from (url ics/webcal)
 *
 *  @param	{string}  url
 *  @param  {string}  info string for tracing
  */
reminderfox.userIO.subscribeOrAddReminder = function (url, info) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
reminderfox.util.dump2Console ('refactor', 
   url + "\n((" + (info += "  % subscribeOrAddReminder") + "))", Components.stack.caller);  //gWrefactor
	var url0 = url.split("\n")[0].toUpperCase();
	
	reminderfox.userIO.icsOrwebcalURL = url.split("\n")[0];
	reminderfox.userIO.icsOrwebcalURLname = url.split("\n")[1];

	if ( url0 != null && url0.length > 0 ) {
		var webcalIndex = url0.indexOf( "WEBCAL://");	// handle webcal address
		if ( webcalIndex != -1 ) {
			reminderfox.userIO.icsOrwebcalURL 
				= "http://" + reminderfox.userIO.icsOrwebcalURL.substring(webcalIndex);
		}

		var subscribedCal = new Array();

		reminderfox.util.JS.dispatch('network');
		reminderfox.network.download.reminderFox_download_Startup_headless_URL(
			reminderfox.core.consts.UI_MODE_HEADLESS_SHOW_ERRORS   /* 2 */,
			reminderfox.userIO.downloadSubscribedCalendarCallback,
			reminderfox.userIO.icsOrwebcalURL,
			subscribedCal,
			null);
	} else {
		//
	}
};

/**
 * ICS/webcal download callback for 'reminderFox_download_Startup_headless_URL'     <br>
 * This is to 'subscribe' or 'add' the iCal/ICS data
 *    @param  [string]  statustxtString
 *    @param  [string]  actionID
 *    @param  [string]  downloadedReminders
 */
reminderfox.userIO.downloadSubscribedCalendarCallback = function (statustxtString, actionID, downloadedReminders) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	reminderfox.core.statusSet ("ICS/webcal download callback: " + actionID + " >" + statustxtString +"<");

	if ( actionID == 2 ) { // reminders were downloaded
		var msg1=  ("\n\n  Link  : " + reminderfox.userIO.icsOrwebcalURLname
						+ "\n  Url   : " + reminderfox.userIO.icsOrwebcalURL
						+ "\n  Events: " + downloadedReminders.length + "\n");				  //$$$locale

		// --- ask user to subscribe or add as reminder ---
		var title = reminderfox.core.getBundle().getString('rf.options.subscribe.title');

		var msgDetails = reminderfox.core.getBundle().getString('rf.options.subscribe.description1')
					+ msg1 
					+ '\n' + reminderfox.core.getBundle().getString('rf.options.subscribe.description2') + '\n';

		var key0 =  reminderfox.core.getBundle().getString('rf.options.subscribe');
		var key1 =  reminderfox.core.getBundle().getString('rf.button.cancel');
		var key2 =  reminderfox.core.getBundle().getString('rf.options.subscribe.add2reminders');

		switch (reminderfox.util.ConfirmEx(title, msgDetails, key0, key1, key2) ) {
			case 0:
				reminderfox.overlay.subscribeWithReminderFox(reminderfox.userIO.icsOrwebcalURL); break;
			case 1:
				// alert ("Canceled	 ;-)");
			break;
			case 2:
				//  How about VEVENTS and VTODOS ??	-- do we get VTODOS here ??
				var _todosArray = new Array();
				reminderfox.iCal.getEvents( "" /*mInvitation*/, downloadedReminders /*reminderFoxEvents*/, _todosArray, "ics/webcal" /*info*/);
		}
	}
};
