if (!reminderfox)     var reminderfox = {};
if (!reminderfox.date)    reminderfox.date = {};
if (!reminderfox.util)    reminderfox.util = {};


if(!reminderfox.msgnr) reminderfox.msgnr = {};
	if (!reminderfox.msgnr.name) reminderfox.msgnr.name = "";
	if (!reminderfox.msgnr.ab3)  reminderfox.msgnr.ab3 = false;


// ***************** Reminderfox date functions    .date.  <<<<<<<<<<<<<<<<<<<<<

reminderfox.date.localeDate = function(dateandtime){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var locDate = dateandtime.toLocaleString();
	return locDate.substring(0, locDate.lastIndexOf(" "));
};


/**
 *   build different date/time formats used with normal mail messages
 * 	@param [object]  Date
 * 	@param [string]  "mailDate"   -->  Fri, 06 Jun 2008 23:47:53 +0200
 * 	                 "mailHeader" -->  Fri Jun 13 20:37:33 2008
 */
reminderfox.date.mailDateTime = function(thisdate, format){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var sDaysOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
	var sMonths = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	var offset = thisdate.getTimezoneOffset();
	
	function dVal(val){
		if (val < 10) 
			val = "0" + val;
		return val;
	}
	
	if (format == "mailDate") { //Fri, 06 Jun 2008 23:47:53 +0200
		var s = sDaysOfWeek[thisdate.getDay()] + ", ";
		s += thisdate.getDate() + " ";
		s += sMonths[thisdate.getMonth()] + " ";
		s += thisdate.getFullYear() + " ";
		
		s += dVal(thisdate.getHours()) + ":";
		s += dVal(thisdate.getMinutes()) + ":";
		s += dVal(thisdate.getSeconds()) + " ";
		if (offset < 0) {
			offset *= -1;
			s += "+";
		}
		else 
			s += "-";
		
		s += dVal(Math.floor(offset / 60));
		s += dVal(Math.floor(offset % 60));
	}
	
	if (format == "mailHeader") { //Fri Jun 13 20:37:33 2008
		var s = sDaysOfWeek[thisdate.getDay()] + " ";
		s += sMonths[thisdate.getMonth()] + " ";
		s += thisdate.getDate() + " ";
		
		s += dVal(thisdate.getHours()) + ":";
		s += dVal(thisdate.getMinutes()) + ":";
		s += dVal(thisdate.getSeconds()) + " ";
		
		s += thisdate.getFullYear() + " ";
	}
	return s;
}

/**
 *   Format Time for ReminderFox based on Options setting 
 * @param  [object]  date
 * @return [string]  time string based on reminderfox.core.consts.USE_24_HOUR_TIME)
  */
reminderfox.date.getTimeString = function (date){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var timeString = null;
	try {
		var hours = date.getHours();
		var AMorPM;
		
		var use24HourTime;
		try {
			use24HourTime = reminderfox.core.consts.reminderFox_prefs.getBoolPref
				(reminderfox.core.consts.REMINDER_FOX_PREF + "." + reminderfox.core.consts.USE_24_HOUR_TIME);
		} 
		catch (e) {
		}
		if (use24HourTime) {
			AMorPM = "";
			if (hours < 10) {
				hours = "0" + hours;
			}
		}
		else {
			AMorPM = reminderfox.core.getBundle().getString("rf.add.time.PM");
			if (AMorPM != "") {
				if (hours < 12) {
					AMorPM = reminderfox.core.getBundle().getString("rf.add.time.AM");
				}
				if (hours == 0) {
					hours = 12;
				}
				if (hours >= 13) {
					hours = hours - 12;
				}
			}
		}
		var minutes = date.getMinutes();
		if (minutes < 10) {
			minutes = "0" + minutes;
		}
		
		timeString = hours + reminderfox.core.getBundle().getString("rf.add.time.delimiter") + minutes;
		if (AMorPM != "") {
			timeString = timeString + " " + AMorPM;
		}
	} 
	catch (e) {
	}
	return timeString;
}


/**
 * Adjust a date/time string to local timezone
 * @param {Object} eventDateString
 * @param {Object} fullDateString
 * @param {Object} reminderDate
 */
reminderfox.date.adjustTimeZones = function (eventDateString, fullDateString, reminderDate){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// if event is stored in UTC time (20051208T224616Z), then take into account UTC offset for the
	// current time
	if (eventDateString.length > 15 && eventDateString.charAt(15) == "Z") {
		var tzOffset = new Date(reminderDate.getFullYear(), reminderDate.getMonth(), reminderDate.getDate()).getTimezoneOffset();
		reminderDate.setMinutes(reminderDate.getMinutes() - tzOffset);
	}
	else {
		// if date contains a Timezone in its specification, handle it if we know the timezone id.
		// DTSTART;TZID=US/Pacific:20071007T100000
		// logic: get target timezone: Pacific  (-8)
		//			get my current timezone offset:  myOffset (-5)
		//			tzOffset = myOffset -targetTimezoneOffset (-5 - -8 = +3)
		var timezoneIndex = fullDateString.indexOf(";TZID=");
		if (timezoneIndex != -1) {
			var endIndex = fullDateString.indexOf(':', timezoneIndex);
			var timezone = fullDateString.substring(timezoneIndex + ";TZID=".length, endIndex);
			timezone = reminderfox.util.trim(timezone.toUpperCase());
			var offset = reminderfox.core.reminderFox_timezones[timezone];
			if (offset == null) {
				// in minutes
				if (timezone == "US/EASTERN" || timezone == "US-EASTERN") {
					offset = 5;
				}
				else 
					if (timezone == "US/CENTRAL" || timezone == "US-CENTRAL") {
						offset = 6;
					}
					else 
						if (timezone == "US/MOUNTAIN" || timezone == "US-MOUNTAIN") {
							offset = 7;
						}
						else 
							if (timezone == "US/PACIFIC" || timezone == "US-PACIFIC") {
								offset = 8;
							}
							else 
								if (timezone == "US/ALASKA" || timezone == "US-ALASKA") {
									offset = 9;
								}
								else 
									if (timezone == "US/HAWAII" || timezone == "US-HAWAII") {
										offset = 11;
									}
									else {
										// if we don't know what this timezone is, do nothing
										offset = 0;
										reminderfox.core.reminderFox_timezones[timezone] = offset;
										return;
									}
				
				/*
				 * Beginning in 2007, most of the United States begins Daylight Saving Time at 2:00 a.m. on the second Sunday in March and reverts to standard time on the first Sunday in November.
				 */
				var startDSTDate = new Date(2007, 2, 11);
				var endDSTDate = new Date(2007, 10, 4);
				
				var startDSTDay = startDSTDate.getDay();
				var weekNumber = reminderfox.date.getWeekNumber(startDSTDate);
				
				var thisMonthsDate = new Date();
				thisMonthsDate.setDate(1); // set to start of the month
				thisMonthsDate.setMonth(2);
				//var reminderWeekDateThisMonth = reminderfox.date.getDateForSpecifiedWeekNumber( startDSTDate, startDSTDay, weekNumber );
				var reminderWeekDateThisMonth = reminderfox.date.getDateForSpecifiedWeekNumber(thisMonthsDate, startDSTDay, weekNumber);
				var startDate = new Date(thisMonthsDate.getFullYear(), startDSTDate.getMonth(), reminderWeekDateThisMonth);
				
				thisMonthsDate.setMonth(10);
				var endDSTDay = endDSTDate.getDay();
				weekNumber = reminderfox.date.getWeekNumber(endDSTDate);
				reminderWeekDateThisMonth = reminderfox.date.getDateForSpecifiedWeekNumber(thisMonthsDate, endDSTDay, weekNumber);
				var endDate = new Date(thisMonthsDate.getFullYear(), endDSTDate.getMonth(), reminderWeekDateThisMonth);
				
				var todaysDate = new Date();
				if (reminderfox.core.compareDates(todaysDate, startDate) >= 0 &&
				reminderfox.core.compareDates(todaysDate, endDate) == -1) {
					// we are in DST; subtract one hour
					offset--;
				}
				
				offset = offset * 60; // convert to minutes
				reminderfox.core.reminderFox_timezones[timezone] = offset * -1; // timezone is negative for US (-0500)
			}
			if (offset == 0) {
				return;
			}
			var tzOffset = new Date().getTimezoneOffset();
			var diff = tzOffset + offset;
			reminderDate.setMinutes(reminderDate.getMinutes() - diff);
		}
	}
}


/**
 * Converts a date string to a Date object
 * @param {string} eventDate
 * @return {object} Date
 */
reminderfox.date.getDateTimeFromString = function (eventDate){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var date = null;
	var timeIndex = eventDate.indexOf("T");
	var month = eventDate.substring(4, 6);
	if (month.indexOf("0") == 0) {
		month = month.substring(1);
	}
	var monthInt = parseInt(month) - 1;
	if (timeIndex == -1) {
		// all day event
		date = new Date(eventDate.substring(0, 4), monthInt, eventDate.substring(6, 8));
	}
	else {
		// event with specific hourly time
		date = new Date(eventDate.substring(0, 4), monthInt, eventDate.substring(6, 8));
		
		var hoursInt = parseInt(eventDate.substring(9, 11));
		var minutsInt = parseInt(eventDate.substring(11, 13));
		date.setHours(hoursInt);
		date.setMinutes(minutsInt);
	}
	return date;
}


/**
 * Converts a date string to a Date object, if UTC string with respect to timezone
 * @param {string} dateString  YYYYMMDDThhmmss{Z}
 * @return {object} Date
 */
reminderfox.date.getStringAsDate = function (dateString){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if (dateString != null && dateString.length > 0) {
		var date;
		var timeIndex = dateString.indexOf("T");
		var month = dateString.substring(4, 6);
		if (month.indexOf("0") == 0) {
			month = month.substring(1);
		}
		var monthInt = parseInt(month) - 1;
		// event with specific hourly time
		date = new Date(dateString.substring(0, 4), monthInt, dateString.substring(6, 8));
		date.setHours(dateString.substring(9, 11), dateString.substring(11, 13), dateString.substring(13, 15));
		
		// if event is stored in UTC time (20051208T224616Z), then take into account UTC offset for the
		// current time
		reminderfox.date.adjustTimeZones(dateString, dateString, date);
		
	}
	return date;
}

/**
 * Generates a date/time string based on a Date object
 * @param {Object} current Date
 * @return {string}  YYYYMMDDThhmmss
 */
reminderfox.date.getDateAsString = function (currentDate){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var dateString = "";
	var year = currentDate.getFullYear();
	var month = currentDate.getMonth() + 1;
	var day = currentDate.getDate();
	if (month < 10) 
		month = "0" + month;
	if (day < 10) 
		day = "0" + day;
	
	var hours = currentDate.getHours();
	var minutes = currentDate.getMinutes();
	var seconds = currentDate.getSeconds();
	if (hours < 10) 
		hours = "0" + hours;
	if (minutes < 10) 
		minutes = "0" + minutes;
	if (seconds < 10) 
		seconds = "0" + seconds;
	
	dateString = year + "" + month + "" + "" + day + "T" + hours + "" + minutes + "" + seconds;
	return dateString;
	// + "00Z" + newline;					// add Z for UTC
}


/**
 * Get a Date with valid day, if calling 'date' isn't valid, sets day to last 
 * valid day.
 * @param {number} year
 * @param {number} month
 * @param {number} date
 * @return {object} Date
 */
reminderfox.date.getValidDateForMonth = function (year, month, date){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var lastValidDate = date;
	
	var lastDayOfMonth = reminderfox.date.getLastDayOfMonth(year, month);
	if (date > lastDayOfMonth) {
		lastValidDate = lastDayOfMonth;
	}
	return lastValidDate;
}

/**
 * 	Calculate the last day of a month
 * 	@param   [integer] year
 * 	@param   [integer] month
 * 	@return  [integer] day of month
 */
reminderfox.date.getLastDayOfMonth = function( year, month) {
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var pastLastDate = new Date( year, month, 32 );
	return 32 - pastLastDate.getDate();
}

/**
 * 	Check Leap year
 * 	@param [integer]  year
 * 	@return [boolean]	leap year == true
 */
reminderfox.date.isLeapYear = function (year){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0)) ? true : false;
}

/**
 * Calculate the weeknumber for a given date
 * @param {Object} currentDate
 * @return {number} weeknumber
 */
reminderfox.date.getWeekNumber = function (currentDate){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var reminderDate = currentDate.getDate();
	var numberOfDay = reminderDate / 7;
	var intvalue = parseInt(numberOfDay);
	if (reminderDate % 7 == 0) {
		intvalue--;
	}
	var weekNumber = intvalue + 1; // 0-based index
	if (weekNumber == 5) {
		weekNumber = -1; // set to last week of month
	}
	return weekNumber;
}


/**
 *   Calculate the date of specific day in a week
 * 
 * @param {Object} currentDate
 * @param {Object} dayNumber
 * @param {Object} weekNumber
 * @return  {object}  date
 */
reminderfox.date.getDateForSpecifiedWeekNumber = function (currentDate, dayNumber, weekNumber){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var firstDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), 1);
	var firstDayOfMonth = firstDate.getDay();
	
	// calculate the date that the first day-of-week falls on (using the day of the first of the month)
	var compareCurrentDay = dayNumber + 1;
	var compareFirstDay = firstDayOfMonth + 1;
	if (compareCurrentDay < compareFirstDay) {
		compareCurrentDay = compareCurrentDay + 7;
	}
	var firstWeekDateVal = (compareCurrentDay - compareFirstDay) + 1;
	var finalDate;
	
	// we have the date that the first day-of-week falls on.  Now let's calculate the Nth day of week
	if (weekNumber == -1) { // last day of week of the month
		var weekNumberCalculation = 5 - 1;
		finalDate = firstWeekDateVal + (weekNumberCalculation * 7);
		var lastDayOfMonth = reminderfox.date.getLastDayOfMonth(currentDate.getFullYear(), currentDate.getMonth());
		if (finalDate > lastDayOfMonth) {
			finalDate = finalDate - 7; // previous (4th) week must be the last week of this month
		}
	}
	else {
		var weekNumberCalculation = weekNumber - 1;
		finalDate = firstWeekDateVal + (weekNumberCalculation * 7);
	}
	return finalDate;
};

/**
 * 	Get 'locale' month string 
 *		@param {number}  0 ..11
 * 	@return {string}  month string from 'locale' bundle
 */
reminderfox.date.getMonthAsText = function (integerValue){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return reminderfox.core.getBundle().getString("rf.options.month." + integerValue + ".name");
}


/**
 *   Generate current UTC date/time string
 * 	@return  {string}  UTC string
 */
reminderfox.date.setDateTimeZ = function() {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var currentDate = new Date();
	var tzOffset = new Date().getTimezoneOffset();
	currentDate.setMinutes( currentDate.getMinutes() + tzOffset );

	return  reminderfox.date.getDateAsString(currentDate)+ "Z";
};


/**
 *  Format a date using the RF prefs: "extensions.reminderFox.listDateLabel"
 * 
 * 	@param {object}	
 * 		null: use current date/time
 * 		number:  as with msgHdr 
 * 		string:  yyyymmddTHHMMSS  or UTC  (ex: 20051208T224616  or  20051208T224616Z = UTC)
 * 		object:  Date
 * 	@return  [string]
 */
reminderfox.date.parseDateTimes = function (pDate) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var thisDate = new Date();
	
	if (typeof(pDate) == "number") thisDate.setTime(pDate);
	if (typeof(pDate) == "object") thisDate = pDate;
	if (typeof(pDate) == "string") thisDate = reminderfox.date.getStringAsDate(pDate);


	var timeString = reminderfox.date.getTimeString(thisDate);
	var _dateVariableString;
	try {
		_dateVariableString = reminderfox.core.getUnicodePref
			(reminderfox.core.consts.REMINDER_FOX_PREF + "." + reminderfox.core.consts.LIST_DATE_LABEL);
	} catch(e) {}
	return reminderfox.date.getDateVariable( null, thisDate, _dateVariableString )
			+ "  " + timeString;
};


reminderfox.date.getDateVariable = function(reminder, date, variableDateString){
	var reminderLabel = variableDateString;
	
	// Replace the [variables]
	var startBracketIndex = reminderLabel.indexOf("[");
	while (startBracketIndex != -1) {
		var endBracketIndex = reminderLabel.indexOf("]", startBracketIndex);
		if (endBracketIndex != -1) {
			// Check for a fishy [
			if (endBracketIndex - startBracketIndex < 3) {
				startBracketIndex = reminderLabel.indexOf("[", ++startBracketIndex);
			}
			else {
				var variable = reminderLabel.substring(startBracketIndex + 1, endBracketIndex);
				var decodedVariable = reminderfox.overlay.decodeReminderLabelVariable(reminder, variable, date);
				var decodedVariableLength = decodedVariable.length;
				var startTrim = startBracketIndex;
				var endTrim = endBracketIndex;
				if (variable == "time" && decodedVariableLength == 0) {
					// trim the ( ) from around time if the time is empty (all-day event)
					if (reminderLabel.charAt(startBracketIndex - 1) == "(" &&
					reminderLabel.charAt(endBracketIndex + 1) == ")") {
						startTrim = startTrim - 1;
						endTrim = endTrim + 1;
					}
				}
				reminderLabel = reminderLabel.substring(0, startTrim) + decodedVariable + reminderLabel.substring(endTrim + 1, reminderLabel.length);
				startBracketIndex = reminderLabel.indexOf("[", startBracketIndex + decodedVariableLength);
			}
		}
	}
	
	return reminderLabel;
}
// ***************** Reminderfox date functions    .date.  >>>>>>>>>>>>>>>>>>>>>


//////////////////// Reminderfox Utilities    .util.    <<<<<<<<<<<<<<<<<<<<<<<<

// ***************** reminderfoxSpecialFunctions 

/**
 * replace escaped commas with regular commas:
 * "Raleigh\, NC" --> "Raleigh, NC"
 */
reminderfox.util.unEscapeCommas = function(stringValue){
	return stringValue.replace(/\\,/g, ",");
}

/**
 * escape commas
 */
reminderfox.util.escapeCommas = function (stringValue){
	return (stringValue == null) ? null : stringValue.replace(/,/g, "\\,")
}


/**
 *   break for long lines   RFC 2445 sec 4.1
 */
reminderfox.util.foldLines = function(line, newline){
	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var result = null;
	var LINE_LENGTH = 75;
	if (line.length <= LINE_LENGTH) {
		result = line + newline;
	}
	else {
		result = line.substring(0, LINE_LENGTH) + newline;
		var index = LINE_LENGTH;
		while ((index + LINE_LENGTH) < line.length) {
			result = result + " " + line.substring(index, index + LINE_LENGTH - 1) + newline; // -1, to account for prepended space
			index = index + LINE_LENGTH - 1;
		}
		result = result + " " + line.substring(index, line.length) + newline;
		;
	}
	return result;
}


/**
 *  Pattern for folded lines: start with a whitespace character
 */
reminderfox.util.FOLDED = /^\s(.*)$/;


/**
 *  ICS lines are split so the max length is no more than 75.
 *  Splitted lines start with a whitespace character.
 *    @param   [string]  content the original ICS lines
 *    @return  [string]  the restored ICS data  (include 'null' lines !)
 */
reminderfox.util.unfoldLines = function (content) {
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var lines = content.replace(/\r\n/g, '\n').split('\n');
	var len = lines.length;
	for (var i = len - 1; i > 0; i--) {
		var matches = reminderfox.util.FOLDED.exec(lines[i]);
		if (matches) {
			lines[i - 1] += matches[1];
			lines[i] = '';
		}
	}
	return lines
}


/**
 * 	Remove blank lines from string array
 */
reminderfox.util.noBlankLines = function (s) {	// Remove blank lines
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var r = [];
	var l = s.length;
	for(var i=0;i<l;i++)
	if (s[i] != "") {r.push(s[i])};
	return r;
};


/** 
 *   Split a string at newlines:   \n (Mac, *nix) or \r\n  (windows)
 *   and unfold lines for no loanger than 75 chars
 */
reminderfox.util.splitOnAllNewlinesAndUnfoldLines = function(input){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var uLines = reminderfox.util.unfoldLines(input);
	return reminderfox.util.noBlankLines(uLines)
}


reminderfox.util.findParentById = function (node, name1, name2){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var parentNode = node;
	while (parentNode != null) {
		if (parentNode.id == name1 || parentNode.id == name2) {
			return parentNode;
		}
		
		parentNode = parentNode.parentNode;
	}
	return parentNode;
}


// http://surf11.com/entry/157/javascript-isinteger-function
reminderfox.util.isInteger = function (s){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return (s.toString().search(/^-?[0-9]+$/) == 0);
}
reminderfox.util.isUnsignedInteger = function (s){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return (s.toString().search(/^[0-9]+$/) == 0);
}


reminderfox.util.mod = function (divisee, base){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return Math.round(divisee - (Math.floor(divisee / base) * base));
}

/**
 *   Trim functions:
 *    .trim      delete leading/trailing white spaces
 *    .trimAll   delete also multiple spaces in string
 */
reminderfox.util.trim = function (s){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return(s.replace(/\s+$/,"").replace(/^\s+/,""));
}
reminderfox.util.trimAll = function (s){
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return(s.replace(/\s+/g," ").replace(/\s+$/,"").replace(/^\s+/,""));
}

/**
 *   Trim string to delete leading/trailing LF, 
 *   replace other LF and white space with space
 */
reminderfox.util.cleanString = function (aString) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return aString.replace(/\n+$/,"").replace(/^\n+/,"").replace(/\xA0|\n/g, ' ');
}


/**
 * Convert a URL to a file path string
 * 
 *  @param  {string}  url
 *  @return {string}  path for url 
 */
reminderfox.util.urlToPath = function (aPath) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var rv = null;
	if (!aPath || !/^file:/.test(aPath))
		return rv;
	var ph = Components.classes["@mozilla.org/network/protocol;1?name=file"]
		.createInstance(Components.interfaces.nsIFileProtocolHandler);
	rv = ph.getFileFromURLSpec(aPath).path;
	return rv;
}


reminderfox.util.escapeHtml = function(s) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return s
		.replace(/&/g, '&amp;')
		.replace(/</g, '&lt;')
		.replace(/>/g, '&gt;')
		.replace(/'/g, '&#039;')
		.replace(/"/g, '&quot;')
		.replace(/\n/g, '<br />');
	}

reminderfox.util.unEscapeHtml = function(s) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return s
		.replace(/&amp;/g, '&')
		/*--------------------------
		.replace(/</g, '&lt;')
		.replace(/>/g, '&gt;')
		.replace(/'/g, '&#039;')
		.replace(/"/g, '&quot;')
		.replace(/\n/g, '<br />')
		----------*/
		;
	}


/**
 *   Get the most recent window by it's 'id'
 *  @param {string}  id of window
 *  @return {object} the window
 */
reminderfox.util.getWindow = function(aWin){
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	return windowManagerInterface.getMostRecentWindow(aWin);
}




/*
 * Firefox           {ec8030f7-c20a-464f-9b0e-13a3a9e97384}
 * SeaMonkey         {92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}
 * Thunderbird       {3550f703-e582-4d05-9a08-453d09bdfdc6}
 * Postbox           postbox@postbox-inc.com
 *
 * Sunbird           {718e30fb-e89b-41dd-9da7-e25a45638b28}
 * Lightning         postbox@postbox-inc.com}
 *
 * Nvu               {136c295a-4a5a-41cf-bf24-5cee526720d5}
 * Mozilla Suite     {86c18b42-e466-45a9-ae7a-9b95ba6f5640}
 * Netscape Browser  {3db10fab-e461-4c80-8b97-957ad5f8ea47}
 * Flock Browser     {a463f10c-3994-11da-9945-000d60ca027b}
 */
reminderfox.util.SEAMONKEY_ID   = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}";
reminderfox.util.THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
reminderfox.util.POSTBOX_ID     = "postbox@postbox-inc.com";
reminderfox.util.SUNBIRD_ID     = "{718e30fb-e89b-41dd-9da7-e25a45638b28}";
reminderfox.util.LIGHTNING_ID   = "{e2fda1a4-762b-4020-b5ad-a41df1933103}";

/**
 *   Get the nsIXULAppInfo of the underlaying application
 *  @return {string}  appId 
 */
reminderfox.util.appId = function(){
	var aID;
	if ("@mozilla.org/xre/app-info;1" in Components.classes) {
		// running under Mozilla 1.8 or later
		aID = Components.classes["@mozilla.org/xre/app-info;1"]
				.getService(Components.interfaces.nsIXULAppInfo).ID;
	}
	else {
		try {
			aID = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefBranch).getCharPref("app.id");
		} 
		catch (e) {
		}
	}
	return aID;
}

/**
 *   Check if a 'messenger' is the underlaying application
 *   @return {Boolean} 
 */
reminderfox.util.messenger = function(){
	return (Components.classes["@mozilla.org/messenger/account-manager;1"] != null);
}

/**
 *   Check if Sunbird or Lightning is installed
 */
reminderfox.util.isSunbirdOrLightning = function(){
	var id = reminderfox.util.appId();
	if (id == null) 
		return false;
	
	if ((id == reminderfox.util.SUNBIRD_ID) || (id == reminderfox.util.LIGHTNING_ID)) {
		return true;
	}
	else {
		return false;
	}
}


/**
 *   "Browse" for 'mail app' path and set in DOM
 *
 **/
reminderfox.util.mailAppStringBrowse = function(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	reminderfox.core.consts.reminderFox_prefsBranch.setCharPref(reminderfox.core.consts.MAIL_PATH, "");
	document.getElementById('mailApp.location.input').value = reminderfox.util.messengerApp().path;
}


// --------- functions for TB,SM ... and 'non' mail (like FX)  ---------
/**
 * Get the  messenger apps location   <br>
 *  - first check prefs if already set   <br>
 *  
 *  - if host app isn't a messenger (TB/PB/SM) like FX     <br>
 *    lets the user browse for a valid messenger app    <br>
 *  
 *    @return  [object]  file for location of 'messenger' application
 */
reminderfox.util.messengerApp = function(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var fileValid = true;
	var mFile = null;
	var mailApp = "";
	
	var mFileServ = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	// sets the default location for messenger app
	var appNameX = Components.classes["@mozilla.org/xre/app-info;1"];
	var appName = appNameX.getService(Components.interfaces.nsIXULAppInfo).name;
	var appID = appNameX.getService(Components.interfaces.nsIXULAppInfo).ID;
	
	var osInfo = reminderfox.core.opSystemInfo();
	
	if (reminderfox.util.messenger()) {
		mFile = mFileServ.get("CurProcD", Components.interfaces.nsIFile);
		
		if (osInfo.indexOf("WINNT") != -1) {
			mFile.append(appName + ".exe");
		}
		if (osInfo.indexOf("Linux") != -1) {
			mFile.append(appName.toLowerCase());
		}
		if (osInfo.indexOf("Darwin") != -1) {
			var mFile = mFileServ.get("LocApp", Components.interfaces.nsIFile);
			mFile.append(appName + ".app");
		}
	}
	
	try {
		var mailApp = reminderfox.core.consts.reminderFox_prefsBranch.getCharPref(reminderfox.core.consts.MAIL_PATH);
	} 
	catch (ex) {
	}
	
	
	try {
		file.initWithPath(mailApp);
		fileValid = file.exists();
	} 
	catch (ex) {
		fileValid = false;
	}
	
	if ((fileValid == false) && (mFile != null)) {
		mailApp = mFile.path;
		file.initWithPath(mailApp);
		fileValid = true;
	}
	
	if (fileValid == false) { // mailApp / OS not valid, ask user
		//gW appPicker	2009-10-03	 +++2do  change for application menu (see FX --> Options --> Applications)
		
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var winTitle = "Select Mail/Messenger Application" // this._prefsBundle.getString("fpTitleChooseApp");
		fp.init(window, winTitle, Components.interfaces.nsIFilePicker.modeOpen);
		fp.appendFilters(Components.interfaces.nsIFilePicker.filterApps);
		
		// Prompt the user to pick an app.  If they pick one, and it's a valid
		// selection, then set it for 'mailto' / 'messenger'
		
		if (fp.show() == Components.interfaces.nsIFilePicker.returnOK &&
		fp.file &&
		reminderfox.util.isValidHandlerExecutable(fp.file)) {
			var handlerApp = reminderfox.util.getLocalHandlerApp(fp.file);
			
		}
		else {
			reminderfox.core.consts.reminderFox_prefsBranch.setCharPref(reminderfox.core.consts.MAIL_PATH, "");
			
			return ""; // return file object
		}
		
		var mailApp = fp.file.path;
		reminderfox.core.consts.reminderFox_prefsBranch.setCharPref(reminderfox.core.consts.MAIL_PATH, mailApp);
		file.initWithPath(mailApp);
	}
	
	if (osInfo.indexOf("Darwin") != -1) {
	
		if (mailApp.toLowerCase().indexOf("-bin") == -1) {
			file.initWithPath(mailApp);
			
			file.append("Contents");
			file.append("MacOS");
			
			if (mailApp.toLowerCase().indexOf("thunderbird") != -1) 
				file.append("thunderbird-bin");
			if (mailApp.toLowerCase().indexOf("seamonkey") != -1) 
				file.append("seamonkey-bin");
			if (mailApp.toLowerCase().indexOf("postbox") != -1) 
				file.append("postbox-bin");
			fileValid = true;
		}
	}
	
	reminderfox.core.consts.reminderFox_prefsBranch.setCharPref(reminderfox.core.consts.MAIL_PATH, mailApp);
	return file; // return file object
}


/**
 *    setup 'mail-app' and 'myAccounts' ---- (for NON msngr app  -- like FX) ----
 **/
reminderfox.util.mailAppSetup = function(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var results = {
		organizer: null,
		attendees: null,
		mode: 'mailApp',
		selectedTyp: 'info',
		schComment: ''
	};
	window.openDialog("chrome://reminderfox/content/mail/invitation.xul", "reminderFox-set-invitationmailAppString", "chrome,resizable,modal", results);
	
	if (results.mode == 'CANCEL') {
		return 'CANCEL';
	} // user pressed 'CANCEL'
	return reminderfox.core.consts.reminderFox_prefsBranch.getCharPref(reminderfox.core.consts.MAIL_SENDER);
}

/**
 *   Collect details from selection (text, or in msngr from header)       <br>
 *
 * @param {Object}   msgHdr; if in msngr builds return object with msgHeader data
 * @param {Object}   selectedText, will be added to msg header detail
 * @return {Object}  collected info as object; if non-msngr just builds object
 */
reminderfox.util.selectionDetails = function (msgHdr, selectedText) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var rv = {};
	rv.messageId = "";
	rv.infos = {};
	rv.infos.url = null;
	rv.url = null;

	if (selectedText == null){
		// get text without leading / trailing LF chars
		selectedText =  reminderfox.util.cleanString 
			(document.commandDispatcher.focusedWindow.getSelection().toString());
	}

	// for NON messenger   grap 'selected' text, url and page titel
	if ((!reminderfox.util.messenger()) || (msgHdr == false)){  
		rv.text = selectedText;
		rv.infos.subject = content.document.title 
			+ ((selectedText != "") ? (": " + selectedText.substring(0, 40)) : "");
		
		// if 'selectedText' has a 'http://' we take that instead of .location.href
		rv.url = content.location.href; 
		
		try { // catch the URL if the source is FX 
			rv.infos.url = event.currentTarget.ownerDocument.activeElement.contentDocument.URL;
		} catch (ex) {}
		return rv;
	}

	try {   // needed: if no message selected ==> would fail !!! 
	if (reminderfox.util.messenger()) {
			// --- get msgHeader Infos ------
			msgHdr  = (msgHdr != null) ? msgHdr : gDBView.hdrForFirstSelectedMessage;

			rv.summary 		= msgHdr.mime2DecodedSubject;
			rv.author 		= msgHdr.mime2DecodedAuthor;
			rv.fromMailadr	= msgHdr.mime2DecodedAuthor;	// need for processing eg REPLY
			rv.recipients	= msgHdr.mime2DecodedRecipients;
			rv.messageId	= "<" + msgHdr.messageId.replace(new RegExp(/\"/g),"") + ">";
	
	// PRIORITY definition for  RmFx and  TB
	// reminderfox.core.consts.PRIORITY_NORMAL = null;  // default
	// reminderfox.core.consts.PRIORITY_IMPORTANT = 1;
	//	TB header.priority:  6= very high;  5=high;  1=normal;  3=low;  2=very low
	
			if (msgHdr.priority >= 5) { 			// for TB 'very high' and 'high'
				rv.priority = 1;	// set RmFx 'Important'
			}

			rv.date = reminderfox.date.parseDateTimes(msgHdr.date);

			rv.infos.subject = reminderfox.core.getBundle().getString("rf.add.mail.message.mail.identifier") + " " + rv.summary;
			rv.infos.date = 			"    " + reminderfox.core.getBundle().getString("rf.add.mail.message.date") + ": " + rv.date;
			rv.infos.author = 		"    " + reminderfox.core.getBundle().getString("rf.add.mail.message.sender") + ": " + rv.author;
			rv.infos.recipients = 	"    " + reminderfox.core.getBundle().getString("rf.add.mail.message.recipients") + ": " + rv.recipients;
			rv.infos.messageId = 	"    " + "MessageID: " + rv.messageId;

			// add message header for the Notes section
			rv.infos.notes = rv.infos.date
				+ "\n" + rv.infos.author
				+ "\n" + rv.infos.recipients
				+ "\n" + rv.infos.messageId;

			if (selectedText == null) selectedText = ""
			if (selectedText != "") {

				var nodeText = reminderfox.util.cleanString (document.popupNode.textContent);
				if (nodeText.indexOf(selectedText) != -1) {
					for (var i=0; i < document.popupNode.children.length; i++) {
						if (document.popupNode.children[i].textContent.indexOf(selectedText)) {
							rv.infos.url = document.popupNode.children[i].href;
						}
					}
				}
			} else {
				if (document.popupNode.textContent != "") {
					selectedText = document.popupNode.textContent;
					rv.infos.url = document.popupNode.href;
					rv.text = rv.infos.notes + selectedText;
				}
			}

			if (selectedText.length > 0) {
				selectedText = "\n\n" + reminderfox.core.getBundle().getString("rf.add.mail.message.details") + "\n" + selectedText;
			}
			rv.text = rv.infos.notes + selectedText;
	}
	} catch (ex) {};

	return rv;
}


/**
 * 	Convert a character stream from Unicode to UTF8 and replace CR --> CRLF
 *   @param  {string}  aSource  source stream
 *   @return {string}  resulting UTF8 string
 */
reminderfox.util.encodeUTF8 = function(aSource){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return reminderfox.util.convertFromUnicode("UTF-8", aSource).replace(/(\r\n)|\n/g, "\r\n");
}

/**
 * 	Convert a character stream from Unicode to other based on definition
 *   @param {string}  aCharset  character set name to convert to
 *   @param {string}  aSource  source stream
 */
reminderfox.util.convertFromUnicode = function(aCharset, aSource){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var unicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
		.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	unicodeConverter.charset = aCharset;
	return unicodeConverter.ConvertFromUnicode(aSource);
}

reminderfox.util.getIOService = function(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if (reminderfox.util.getIOService.mObject === undefined) {
		reminderfox.util.getIOService.mObject = Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService2);
	}
	return reminderfox.util.getIOService.mObject;
}

/**
 *   Build a temporary file using the ICS UID name
 *   @param  {string}  rmFx_UID
 *   @return {string}  tmp file path in OS tmp dir
 */
reminderfox.util.buildUIDFile = function(rmFx_UID){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var tempDir = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
	
	tempDir.append("tempMsg" + rmFx_UID);
	
	return tempDir.path;
}

/**
 *  Create file.path for a file located in same dir as the current
 *  ReminderFox ICS file location
 *  @param   {string}  fileName
 *  @return  {string}  file path 
 */
reminderfox.util.filePath4storePath = function(fileName){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// set 'path' to same dir as 'reminderfox.ics' file      
	var sfile = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	
	sfile.initWithPath(reminderfox.core.getReminderStoreFile().parent.path);
	sfile.append(fileName);
	return sfile.path;
}

/**
 *   Read character file and convert to UTF8 string
 * 	@param  {string}  file name
 *    @return {string}  UTF8 character string
 */
reminderfox.util.readInFileContents = function(tmpFile){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var sfile = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	sfile.initWithPath(tmpFile);
	
	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance(Components.interfaces.nsIFileInputStream);
	try {
		is.init(sfile, 0x01, 00004, null);
	} 
	catch (e) {
		reminderfox.util.PromptAlert("Could not read reminder file: " + e.name + " -- " + e.message);
		return null;
	}
	// Now, read from the stream
	var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		.createInstance(Components.interfaces.nsIScriptableInputStream);
	scriptableStream.init(is);
	
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
			.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8"; // The character encoding you want, using UTF-8 here
	var chunk = scriptableStream.read(scriptableStream.available());
	scriptableStream.close();
	var input = null;
	try {
		input = converter.ConvertToUnicode(chunk);
	} 
	catch (e) {
		input = chunk;
	}
	return input;
}

reminderfox.util.makeMsgFile = function(content, tempFile){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var sfile = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	try {
		sfile.initWithPath(tempFile);
	} 
	catch (ex) {
		return null;
	}
	if (sfile.exists()) {
		sfile.remove(true);
	}
	sfile.create(sfile.NORMAL_FILE_TYPE, 0600);
	var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
	stream.init(sfile, 2, 0x200, false); // open as "write only"
	stream.write(content, content.length);
	stream.close();
	return sfile;
}

reminderfox.util.makeMsgFile8 = function(outputStr, file){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var sfile = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	sfile.initWithPath(file);
	
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance(Components.interfaces.nsIFileOutputStream);
	outputStream.init(sfile, 0x04 | 0x08 | 0x20, 420, 0);
	
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
		.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	
	var chunk = null;
	try {
		chunk = converter.ConvertFromUnicode(outputStr);
	} 
	catch (e) {
		chunk = outputStr;
	}
	outputStream.write(chunk, chunk.length);
	
	var fin = converter.Finish();
	if (fin.length > 0) 
		outputStream.write(fin, fin.length);
	outputStream.close();
	return sfile;
}

/**
 *     Debugging support, prompts an Alert and writes it to console
 */
reminderfox.util.PromptAlert = function(msgErr){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	
	var loggedAt = "[[" + Components.stack.caller.filename + "  # " +
	Components.stack.caller.lineNumber +
	"]]";
	
	promptService.alert(window, "ReminderFox Alert : \n\n", msgErr);
	reminderfox.util.dump2Console("promptAlert", msgErr, loggedAt)
};


/**
 * 	@param  [string]	logControl		checked against defaults (promptAlert|error|general)
 *								or reminderfox.core.consts.REMINDER_FOX_PREF + ".debug.LogControl, 
 * 							dumps only if matches
 * 	@param  [string]	logString
 * 	@param  [null|string|object]	loggedAt		optional output of [[caller]] info
 * 							if 'object' also about [<caller>] of [[caller]]
 */
reminderfox.util.dump2Console = function(logControl, logString, loggedAt){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var loggingString = ",promptAlert,error,general";
	
	try {
		loggingString = reminderfox.core.consts.reminderFox_prefs.getCharPref(reminderfox.core.consts.REMINDER_FOX_PREF + ".debug.LogControl") +
		loggingString;
	} 
	catch (ex) {
	}
	
	if (loggingString.search(logControl) != -1) {
		var _consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		
		if (loggedAt == null) {
			loggedAt = "\n[[" + Components.stack.caller.filename + "  #" +
			Components.stack.caller.lineNumber +
			"]]";
		}
		else 
			if (typeof(loggedAt) == "string") {
				loggedAt = "\n" + loggedAt
			}
			else 
				if (typeof(loggedAt) == "object") {
					loggedAt = "\n[<" + loggedAt.filename + "  #" + loggedAt.lineNumber + ">]" +
					"\n[[" +
					Components.stack.caller.filename +
					"  #" +
					Components.stack.caller.lineNumber +
					"]]";
				}
		_consoleService.logStringMessage("ReminderFox   {log: " + logControl + "}  " + logString + loggedAt);
	}
};


/**
 *    Generic function to copy the data to Clipboard
 */
reminderfox.util.copytoClipboard = function(data){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Generic function to copy the data to Clipboard 
	var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
	clipboard = clipboard.getService(Components.interfaces.nsIClipboardHelper);
	clipboard.copyString(data);
};

/**
 *    Generic function to get the text from Clipboard
 *    @note:  ev. change to "transferable.getAnyTransferData(bestFlavour, dataObj, len);"
 *             see 'rmFxUserIO.js'
 */
reminderfox.util.copyTextfromClipboard = function(){ //gW_AddEvent
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	if (!clip) 
		return null;
	
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) 
		return null;
	
	trans.addDataFlavor("text/unicode");
	
	clip.getData(trans, clip.kGlobalClipboard);
	
	var str = new Object();
	var strLength = new Object();
	
	try { // 'try' to prevent error with empty or non-text clipboard content
		trans.getTransferData("text/unicode", str, strLength);
		
		if (str) 
			str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
		if (str) 
			var pastetext = str.data.substring(0, strLength.value / 2);
		
		if (pastetext != "") 
			return pastetext;
	} 
	catch (ex) {
	};
	return null;
};


/**
 *
 * 	rmFxUtil Dialog Confirm Service to support 2 or 3 key choice
 *
 <br>            [key0] [key1]
 <br>       or   [key0] [key2] [key1]
 *
 * 	@param	title, the headline of dialog
 * 	@param	msg, typically a question
 * 	@param	key0
 * 	@param	key1
 * 	@param	key2, optional, decides if 2 or 3 buttons
 */
reminderfox.util.ConfirmEx = function(title, msg, key0, key1, key2){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	
	var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1; // flags = [integer] 32639
	if (!!key2) {
		var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 +
		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2; // flags = [integer] 8355711
	}
	return promptService.confirmEx(window, title, msg, flags, key0, key1, key2, null, {});
};



// Utilities  from \mail\components\preferences\applications.js

reminderfox.util.getDisplayNameForFile = function(aFile){ // +++2do gW_OSspecfic ???
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//@line 85 "e:\buildbot\win32_build\build\mail\components\preferences\applications.js"
	if (aFile instanceof Components.interfaces.nsILocalFileWin) {
		try {
			return aFile.getVersionInfoField("FileDescription");
		}
		catch (ex) { // fall through to the file name
		}
	}
	return aFile.leafName;
}

reminderfox.util.getLocalHandlerApp = function(aFile){ // +++2do gW_OSspecfic ???
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var localHandlerApp = Components.classes["@mozilla.org/uriloader/local-handler-app;1"].createInstance(Components.interfaces.nsILocalHandlerApp);
	localHandlerApp.name = reminderfox.util.getDisplayNameForFile(aFile);
	localHandlerApp.executable = aFile;
	return localHandlerApp;
};


reminderfox.util.isValidHandlerExecutable = function(aExecutable){ // +++2do gW_OSspecfic ???
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	return aExecutable &&
	aExecutable.exists() &&
	aExecutable.isExecutable() &&
	//@line 905 "e:\buildbot\win32_build\build\mail\components\preferences\applications.js"
	aExecutable.leafName != ".exe";
	//@line 913 "e:\buildbot\win32_build\build\mail\components\preferences\applications.js"
};


/**
 *    Add CATEGORIES item to reminder, no dups
 */
reminderfox.util.addCategory4Import = function(reminder, categoryItem){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	var categoryItemLC = categoryItem.toLowerCase(); //   "invitation";  
	if (reminder.categories != null && reminder.categories.length > 0) {
		if (reminder.categories.toLowerCase().indexOf(categoryItemLC) == -1) {
			reminder.categories = reminder.categories + ", " + categoryItem;
		}
	}
	else {
		reminder.categories = categoryItem;
	}
	return reminder;
};


/**
 *    Add Events/Todos to exsitings and write result to ReminderFox 'statusline'
 * 	@param {object} newEvents
 * 	@param {object} newTodos
 */
reminderfox.util.addMultipleEvents = function (newEvents, newTodos) {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// merge
	var existingEvents = reminderfox.core.getReminderEvents();
	var existingTodos = reminderfox.core.getReminderTodos();  //  ALL  todos
	var rvEvent = reminderfox.core.mergeEvents(existingEvents, newEvents  );
	var rvTodo = reminderfox.core.mergeTodos( existingTodos, newTodos );

	reminderfox.core.reminderFoxEvents = existingEvents;
	reminderfox.core.reminderFoxTodosArray = existingTodos;

	reminderfox.core.importRemindersUpdateAll(false, null );

	// write to status !!
	var xEvents= reminderfox.core.getBundle().getString("rf.html.heading.reminders");
	var xToDos = reminderfox.core.getBundle().getString("rf.html.heading.todos");
	var xImported  = reminderfox.core.getBundle().getString("rf.reminders.imported");	//"imported";
	var xExists  = reminderfox.core.getBundle().getString("rf.reminders.exists");		//"already exists";

	var msgText =  xEvents + " : " + rvEvent.importNo + " " + xImported
			+ ",  " + rvEvent.existNo + " " + xExists +"."
			+ "\n" + xToDos + " : " + rvTodo.importNo  + " " + xImported
			+ ",  " + rvTodo.existNo + " " + xExists + "." ;

	reminderfox.core.statusSet (msgText);
	return true;
};



// *****************************************************************************
/**
 * Dispatcher
 * Used as 'chrome' Loader for specific usecases.
 * Loading will only executed if the '.JS' isn't loaded already,
 * checked with an object expected to be loaded with .JS file;
 * ex "reminderfox.iCal"  defined in "rmFxIcalMail.js"
 *
 * @param  id    name of a package with one or more 'chrome' files and
 *  (optional a function to be called after loading; this is added to
 *   simplify definition in XUL)
 * @param  arg   argument(s) to be passed to the optional call
 *
 */
reminderfox.util.JS = {
	// *****************************************************************************
	mail: "chrome://reminderfox/content/mail/rmFxMail.js",
	iCal: "chrome://reminderfox/content/mail/rmFxIcalMail.js",
	iSchedule: "chrome://reminderfox/content/mail/schedule.js",
	abCard: "chrome://reminderfox/content/mail/addContact2Reminder.js",
	sendPlus: "chrome://reminderfox/content/mail/rmFxSendwReminder.js",
	tagging: "chrome://reminderfox/content/mail/rmFxMsgTagging.js",
	
	userIO: "chrome://reminderfox/content/utils/rmFxUserIO.js",



	"network.download": "chrome://reminderfox/content/network/download.js",
	"network.upload": "chrome://reminderfox/content/network/upload.js",
	"network.services": "chrome://reminderfox/content/network/networkService.js",
	"network.password": "chrome://reminderfox/content/network/passwordManagerUtils.js",


	// **** experimental only ****
		jcalendar: "chrome://reminderfox/content/js/jCalDef.js",
		icalendar: "chrome://reminderfox/content/js/jquery.icalendar.js",
		jquery: "chrome://reminderfox/content/js/jquery-1.4.3.min.js",

	
	dispatcher: function(object){
		var status = true;
		
		// for multi-package (network.upload), check if first segment is defined; if so,
		// check for second segment as well
		if( object.indexOf( "." ) != -1 ) { 
			var index = object.indexOf( ".");
			var segment1 = object.substring( 0, index );
			var segment2 = object.substring( index + 1);
			status = typeof reminderfox[segment1] == 'undefined';
			if ( !status ) {
				status = typeof reminderfox[segment1][segment2] == 'undefined';
			}
		}
		else { 
			status = typeof reminderfox[object] == 'undefined';
		}
		if (status) {
			Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
			.getService(Components.interfaces.mozIJSSubScriptLoader)
			.loadSubScript(this[object]);
		}
		
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
		
		consoleService.logStringMessage("ReminderFox     {dispatch: " +
		object + "=" + status + "}\n" + this.loggedAt);
	},
	
	
	/**
	 *  for multi-package (like 'jcalendar,jquery,icalendar'), check if a package is defined 
	 *  for the first string (eg: 'jcalendar'),    <br>
	 *  -- if so return, do nothing;   <br>
	 *  -- if NOT, load  all packages without further checking
	 *  
	 * @param {string} object
	 */
	dispatcher2: function(packages){
		var status = null;
		var allPackages = packages.split(",");
		
		var pLength = allPackages.length;
		var aPackage = reminderfox.util.trim(allPackages[0])
		
		status = typeof reminderfox[aPackage] == 'undefined';
		this.loader (aPackage, status)
		
		if (status) {   // if first has been loaded go for the rest
			for (var i= 1; i < pLength; i++) {
				aPackage = reminderfox.util.trim(allPackages[i]);
				this.loader (aPackage, "force")
			}
		}
	},
	
	
	loader : function (object, status) {
		
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
		
		consoleService.logStringMessage("ReminderFox     {dispatch: " +
		object + "=" + status + "}\n" + this.loggedAt);
		
		if (status == true) {
			Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
			.getService(Components.interfaces.mozIJSSubScriptLoader)
			.loadSubScript(this[object]);
		}
	},
	
	
	loggedAt: '',
	
	dispatch: function(id, arg){
		this.loggedAt = "[[" + Components.stack.caller.filename + "  # " +
		Components.stack.caller.lineNumber + "]]";
		
		switch (id) {
			// *** XUL calls for dispachting and optional  fct call ***
			case "getiCalMailed":{
				this.dispatcher("iCal");
				this.dispatcher("mail");
				reminderfox.iCal.getiCalwCMenu(arg);
				break;
			}
			case "addReminder4Contact":{
				this.dispatcher("abCard");
				this.dispatcher("iCal");
				reminderfox.abCard.addReminder4Contact(arg);
				break;
			}
			case "msgSendwReminder":{
				this.dispatcher("sendPlus");
				reminderfox.sendPlus.reminder();
				break;
			}


			// *** just loading ****
			case "mail":{
				this.dispatcher("mail");
				this.dispatcher("tagging");
				break;
			}
			case "iCalMail":{
				this.dispatcher("iCal");
				break;
			}
			case "sendPlus":{
				this.dispatcher("sendPlus");
				this.dispatcher("tagging");
				this.dispatcher("mail");
				break;
			}
			case "tagging":{
				this.dispatcher("tagging");
				this.dispatcher("sendPlus");
				break;
			}
			case "tag":{
				this.dispatcher("tagging");
				break;
			}
			case "network":{
				this.dispatcher("network.upload");
				this.dispatcher("network.download");
				this.dispatcher("network.services");
				this.dispatcher("network.password");
				break;
			}
			case "userIO":{
				this.dispatcher("userIO");
				reminderfox.userIO.go(arg);
				break;
			}
			case "icalendar":{
				this.dispatcher2("jcalendar,jquery,icalendar");
				break;
			}
		}
	}
};